 {$IFDEF DMPI}
         {$C MOVEABLE DEMANDLOAD DISCARDABLE}
 {$ENDIF}
 UNIT Convert;
 {
   UNITE DES COVERSIONS
   Sad LANKRI
   2000
 }

 INTERFACE

 USES CrtPlus;

 TYPE StringArray = ARRAY[0..255] OF CHAR;

 FUNCTION Str2Num   (S : STRING)   : LONGINT;
 FUNCTION Num2Str   (N : LongInt)  : STRING;
 PROCEDURE Str2ASCIIZ (S : STRING; VAR ASCIIZ : StringArray);
 FUNCTION GetASCIIZLength (S : StringArray) : BYTE;
 FUNCTION ASCIIZ2Str (S : StringArray) : STRING;
 FUNCTION Puissance (Nombre, Exposant : BYTE)   : LONGINT;
 FUNCTION IsBitSet  (X : LongInt; BitNo : BYTE) : BOOLEAN;
 FUNCTION Hex2Dec   (Hex : STRING)  : LONGINT;
 FUNCTION Dec2Hex   (Dec : LONGINT) : STRING;
 FUNCTION Dec2Bin   (Dec : LongInt) : STRING;
 FUNCTION Bin2Dec   (Bin : STRING)  : LongInt;
 FUNCTION Degree2Rad (Deg : REAL) : REAL;
 FUNCTION Rad2Degree (Rad : REAL) : REAL;

 PROCEDURE ClearBit (VAR X : LongInt; BitNo : BYTE);
 PROCEDURE SetBit   (VAR X : LongInt; BitNo : BYTE);

 IMPLEMENTATION

 FUNCTION Str2Num;
 VAR ERR : INTEGER;
     X   : LONGINT;
 BEGIN
      Val(S, X, Err);
      Str2Num:= X;
 END;

 FUNCTION Num2Str;
 VAR S : STRING;
 BEGIN
      Str(N,S);
      Num2Str:= S;
 END;

 PROCEDURE Str2ASCIIZ;
 VAR I : BYTE;
 BEGIN
      FOR I:= 0 TO 255 DO ASCIIZ[I]:= #0;
      FOR I:= 0 TO Length(S)-1 DO ASCIIZ[I]:= S[I+1];
 END;

 FUNCTION GetASCIIZLength;
 VAR I : BYTE;
 BEGIN
      I:= 0;
      FOR I:= 0 TO 255 DO IF S[I] = #0 THEN BEGIN
          GetASCIIZLength:= I;
          Break;
      END;
 END;

 FUNCTION ASCIIZ2Str;
 VAR I : BYTE;
     R : STRING;
 BEGIN
      R[0]:= Chr(GetASCIIZLength(S));
      FOR I:= 1 TO GetASCIIZLength(S) DO R[I]:= S[I-1];
      ASCIIZ2Str:= R;
 END;

 FUNCTION Puissance;
 VAR I : BYTE;
     J : LONGINT;
 BEGIN
      Puissance:= 1; J:= 1;
      FOR I:= 1 TO Exposant DO J:= J * Nombre;
      Puissance:= J;
 END;

 FUNCTION IsBitSet;
 BEGIN
      IF (X AND Puissance(2,BitNo)) <> 0 THEN IsBitSet:= TRUE ELSE IsBitSet:= FALSE;
 END;

 PROCEDURE ClearBit;
 BEGIN
      IF IsBitSet(X, BitNo) = TRUE THEN X:= X AND (X-Puissance(2,BitNo));
 END;

 PROCEDURE SetBit;
 BEGIN
      IF IsBitSet(X, BitNo) = FALSE THEN X:= X OR (X+Puissance(2,BitNo));
 END;

 FUNCTION Dec2Bin;
 VAR Reste : 0..1;
     Quot  : LONGINT;
     S     : STRING;
 BEGIN
      S:= ''; Quot:= Dec;
      REPEAT
            Reste:= Quot MOD 2; Quot:= Quot DIV 2;
            IF Reste = 1 THEN S:= '1'+S ELSE S:= '0'+S;
      UNTIL Quot = 0;
      Dec2Bin:= S;
 END;

 FUNCTION Bin2Dec;
 VAR I : BYTE;
     X : LongInt;
 BEGIN
      X:= 0;
      FOR I:= Length(Bin) DOWNTO 1 DO BEGIN
          X:= X+Str2Num(Bin[I])*Puissance(2,Length(Bin)-I);
      END;
      Bin2Dec:= X;
 END;

 FUNCTION Hex2Dec;
 CONST HexVal : ARRAY ['A'..'F'] OF 10..15 = (10,11,12,13,14,15);
 VAR I,J      : BYTE;
     Res      : ^LONGINT;
 BEGIN
      New(Res);
      Res^:= 0; J:= Length(Hex)-1;
      FOR I:= 1 TO Length(Hex) DO BEGIN
          IF (UpCase(Hex[I]) >= 'A') AND (UpCase(Hex[I]) <= 'F') THEN
             Res^:= Res^ + HexVal[UpCase(Hex[I])]*Puissance(16,J)
          ELSE
             Res^:= Res^ + Str2Num(Hex[I])*Puissance(16,J);
          J:= J-1;
      END;
      Hex2Dec:= Res^;
      Dispose(Res)
 END;

 FUNCTION Dec2Hex;
 CONST HexDigits : ARRAY [0..15] OF CHAR = '0123456789ABCDEF';
 VAR Reste : 0..15;
     Quot  : LONGINT;
     S     : STRING;
 BEGIN
      S:= ''; Quot:= Dec;
      REPEAT
            Reste:= Quot MOD 16; Quot:= Quot DIV 16;
            S:= HexDigits[Reste]+S;
      UNTIL Quot = 0;
      Dec2Hex:= S;
 END;

 FUNCTION Degree2Rad;
 BEGIN
      Degree2Rad:= (Deg*Pi)/180;
 END;

 FUNCTION Rad2Degree;
 BEGIN
      Rad2Degree:= (Rad*180)/Pi;
 END;

 BEGIN
 END.