 {$IFDEF DMPI}
         {$C MOVEABLE DEMANDLOAD DISCARDABLE}
 {$ENDIF}
 UNIT Keyboard;
 {
   UNITE POUR LES E/S CLAVIER
   Sad LANKRI,
   1999 - 2000

   Dernire MAJ : 14/05/00

   REMARQUES :
           * LES NOMS DES TOUCHES RENVOYES SONT SOUS FORME DE CHAINES DE
           CARACTERES EN MAJUSCULES ET LES TOUCHES CLASSEES SELON UN
           CLAVIER 101/102/105 TOUCHES FRANCAIS
           * POUR LA PROCEDURE GetLeds, LES STATUS DES LEDS DEVRONT ETRE
           FOURNIS DANS L'ORDRE : NumLock, CapsLock, ScrollLock
 }

 INTERFACE

 USES Dos, CrtPlus, Convert;

 TYPE KeyInfo = RECORD
              ScanCode, ASCII : BYTE;
              Num, Caps, Scroll, ShiftG, ShiftD, Ctrl, Alt, Extend : BOOLEAN;
              Name : STRING;
      END;


 PROCEDURE GetLeds(VAR Num,Caps,Scroll : OnOff);
 PROCEDURE SetLeds(Num,Caps,Scroll : OnOff);
 PROCEDURE GetKey(VAR Key : KeyInfo);

 IMPLEMENTATION

 PROCEDURE GetLeds(VAR Num,Caps,Scroll : OnOff);
 VAR Regs : Registers;
 BEGIN
      Regs.AH:= $02;
      Intr($16, Regs);
      IF (Regs.AL AND 16) <> 0 THEN Scroll:= On ELSE Scroll:= Off;
      IF (Regs.AL AND 32) <> 0 THEN Num:= On    ELSE Num:= Off;
      IF (Regs.AL AND 64) <> 0 THEN Caps:= On   ELSE Caps:= Off;
 END;

 PROCEDURE SetLeds(Num,Caps,Scroll : OnOff);
 VAR Regs : Registers;
 BEGIN
      IF Num = On THEN Mem[Seg0040:$0017]:= Mem[Seg0040:$0017] OR 32 ELSE Mem[Seg0040:$0017]:= Mem[Seg0040:$0017] AND (NOT 32);
      IF Caps = On THEN Mem[Seg0040:$017]:= Mem[Seg0040:$0017] OR 64 ELSE Mem[Seg0040:$0017]:= Mem[Seg0040:$0017] AND (NOT 64);
      IF Scroll = On THEN Mem[Seg0040:$17]:= Mem[Seg0040:$017] OR 16 ELSE Mem[Seg0040:$0017]:= Mem[Seg0040:$0017] AND (NOT 16);
      Regs.AH:= 1;
      Intr($16, Regs);
 END;

 PROCEDURE GetKey(VAR Key : KeyInfo);
 VAR Regs : Registers;
 BEGIN
      Key.Name:= '';
      Regs.AH:= $10;
      Intr($16, Regs);
      WITH Key DO BEGIN
           ScanCode:= Regs.AH;
           ASCII:= Regs.AL;
           IF (Regs.AL = $E0) AND (Regs.AH <> 0) THEN Extend:= TRUE ELSE Extend:= FALSE;

           Regs.AH:= $02;
           Intr($16, Regs);
           IF (Regs.AL AND 1) <> 0 THEN ShiftD:= TRUE  ELSE ShiftD:= FALSE;
           IF (Regs.AL AND 2) <> 0 THEN ShiftG:= TRUE  ELSE ShiftG:= FALSE;
           IF (Regs.AL AND 4) <> 0 THEN Ctrl:= TRUE    ELSE Ctrl:= FALSE;
           IF (Regs.AL AND 8) <> 0 THEN Alt:= TRUE     ELSE Alt:= FALSE;
           IF (Regs.AL AND 16) <> 0 THEN Scroll:= TRUE ELSE Scroll:= FALSE;
           IF (Regs.AL AND 32) <> 0 THEN Num:= TRUE    ELSE Num:= FALSE;
           IF (Regs.AL AND 64) <> 0 THEN Caps:= TRUE   ELSE Caps:= FALSE;

           IF (ShiftD = TRUE) OR (ShiftG = TRUE) THEN Name:= Name+'SHIFT+';
           IF Ctrl THEN Name:= Name+'CTRL+';
           IF Alt  THEN Name:= Name+'ALT+';
           IF Extend THEN Name:= Name+'GRAY ';

           CASE Port[$60] OF
                1      : Name:= Name+'ESC';
                59..68 : Name:= Name+'F'+Num2Str(Port[$60]-58);
                87..88 : Name:= Name+'F'+Num2Str(Port[$60]-76);
                42     : Name:= Name+'PrintScr';
                55     : IF ASCII = Ord('*') THEN Name:= Name+'*' ELSE Name:= Name+'PrintScr';
                14     : Name:= Name+'BACKSPACE';
                82     : Name:= Name+'INSERT';
                83     : Name:= Name+'SUPPR';
                71     : Name:= Name+'HOME';
                79     : Name:= Name+'END';
                73     : Name:= Name+'PGUP';
                81     : Name:= Name+'PGDOWN';
                72     : Name:= Name+'UP';
                75     : Name:= Name+'LEFT';
                80     : Name:= Name+'DOWN';
                77     : Name:= Name+'RIGHT';
                28     : Name:= Name+'ENTER';
                57     : Name:= Name+'SPACE';
                91     : Name:= Name+'LEFT W95 STARTUP MENU';
                92     : Name:= Name+'W95 CONTEXTUAL MENU';
                93     : Name:= Name+'RIGHT W95 STARTUP MENU';
                15     : Name:= Name+'TAB';
                16     : Name:= Name+'A';
                17     : Name:= Name+'Z';
                18     : Name:= Name+'E';
                19     : Name:= Name+'R';
                20     : Name:= Name+'T';
                21     : Name:= Name+'Y';
                22     : Name:= Name+'U';
                23     : Name:= Name+'I';
                24     : Name:= Name+'O';
                25     : Name:= Name+'P';
                26     : Name:= Name+'^';
                27     : Name:= Name+'$';
                30     : Name:= Name+'Q';
                31     : Name:= Name+'S';
                32     : Name:= Name+'D';
                33     : Name:= Name+'F';
                34     : Name:= Name+'G';
                35     : Name:= Name+'H';
                36     : Name:= Name+'J';
                37     : Name:= Name+'K';
                38     : Name:= Name+'L';
                39     : Name:= Name+'M';
                40     : Name:= Name+'';
                86     : Name:= Name+'<';
                44     : Name:= Name+'W';
                45     : Name:= Name+'X';
                46     : Name:= Name+'C';
                47     : Name:= Name+'V';
                48     : Name:= Name+'B';
                49     : Name:= Name+'N';
                50     : Name:= Name+',';
                51     : Name:= Name+';';
                52     : Name:= Name+':';
                53     : IF ASCII = Ord('/') THEN Name:= Name+'/' ELSE Name:= Name+'!';
                ELSE Name:= Name + Chr(ASCII);
           END;
      END;
 END;

 BEGIN
 END.