 UNIT TOBJECTS;
 {
   UNITE DES OBJECTS EN MODE TEXTE
   *
   Des objets simples et faciles d'utilisation totalement indpendants
   entre eux, le contraire de TURBO VISION, dans lequel le Scrolling,
   le dessin des boites, l'affichage ...   representent des objets 
   parts entires qu'il faut lier pour obtenir par exemple des menus.
   Inconvnient : ces objects n'offrent pas un grand choix de
   personnalisation. Il faut crer des descendants.
   *
   Sad LANKRI,
   1999 - 2000

   Dernire MAJ : 04/09/2000
 }

 INTERFACE

 USES CrtPlus, Keyboard, Convert;

 TYPE MenuStatus      = (NormalMenu, DisabledMenu);
      ObjectScrolling = (Active, Inactive);
      BoxStatus       = (CheckedBox, UncheckedBox, UnavailableBox);
      RadioStatus     = (CheckedRadio, UncheckedRadio);
      ButtonStatus    = (DefaultButton, DisabledButton, NormalButton);
      LabelStatus     = (NormalLabel, DisabledLabel);

      TColorRec       = RECORD
                      X,Y : BYTE;
      END;

      TListePalette = RECORD
                    Selected, Unselected, Implicite : TColorRec;
      END;

      TPullDownListePalette = RECORD
                            SelectedItem, UnselectedItem,
                            SelectedField, UnselectedField,
                            Border, Arrow : TColorRec;
      END;

      TMenuPalette  = RECORD
                    Selected, Unselected, Shortcut, DisabledSelected,
                    DisabledUnselected, KeyWordSelected, KeyWordUnselected,
                    KeyWordSelectedDisabled, KeyWordUnselectedDisabled
                    : TColorRec;
      END;

      TButtonPalette = RECORD
                    Selected, Unselected, Disabled,
                    Default : TColorRec;
      END;

      TFieldPalette = RECORD
                    Selected, Unselected, SelectedTitle,
                    UnselectedTitle, Arrows : TColorRec;
      END;

      TDesktopPalette = RECORD
                      Desktop, HlpContext : TColorRec;
      END;

      TWindowPalette = RECORD
                     Active, Passive, Title, Close : TColorRec;
      END;

      TCheckBoxesPalette = RECORD
                         Selected, Unselected, Disabled, BoxChecked,
                         BoxUnchecked : TColorRec;
      END;

      TRadioPalette = RECORD
                    Selected, Unselected, RadioChecked,
                    RadioUnchecked : TColorRec;
      END;

      TLabelPalette = RECORD
                    Selected, Unselected, Disabled : TColorRec;
      END;

      PMenuItem = ^TMenuItem;
      TMenuItem = RECORD
                Name : STRING;
                KeyWord : STRING[25]; {Touche raccourci}
                Command : WORD; {Numro de commande  gnrer lors ENTREE}
                Status : MenuStatus; {Normal/Disabled}
                Suivant, Precedent : PMenuItem;
      END;

      PFieldItem = ^TFieldItem;
      TFieldItem = RECORD
                 Name : STRING;
                 Data : STRING;
                 Ch   : Chars;
                 MaxLength : BYTE;
                 Ligne,Col : BYTE;
                 StartSel, EndSel : BYTE;
                 FType     : FieldType;
                 Suivant,Precedent : PFieldItem
      END;

      PButtonItem = ^TButtonItem;
      TButtonItem = RECORD
                  Name : STRING;
                  Ligne,Col : BYTE;
                  Command   : WORD;
                  Status    : ButtonStatus;
                  Suivant,Precedent : PButtonItem;
      END;

      PListeItem = ^TListeItem;
      TListeItem = RECORD
                 Name : STRING[80];
                 Suivant,Precedent : PListeItem;
      END;

      PCheckBoxItem = ^TCheckBoxItem;
      TCheckBoxItem = RECORD
                    Name : STRING;
                    Command : WORD;
                    Status  : BoxStatus;
                    Suivant,Precedent : PCheckBoxItem;
      END;

      PRadioItem = ^TRadioItem;
      TRadioItem = RECORD
                 Name : STRING;
                 Command : WORD;
                 Status  : RadioStatus;
                 Suivant,Precedent : PRadioItem;
      END;

      PWindowItem = ^TWindowItem;
      TWindowItem = RECORD
                  Title : STRING;
                  Shadow : OnOff;
                  Rect  : TRect;
                  Suivant,Precedent : PWindowItem;
      END;

      PLabelItem = ^TLabelItem;
      TLabelItem = RECORD
                 Name : STRING;
                 Ligne,Col : BYTE;
                 Status : LabelStatus;
                 Suivant,Precedent : PLabelItem;
      END;

      TDesktop = OBJECT
               DesktopChar : CHAR;
               Palette     : TDesktopPalette;
               Rect        : TRect;

               CONSTRUCTOR Init(L1,C1,L2,C2 : BYTE);
               PROCEDURE   DrawDesktop; VIRTUAL;
               PROCEDURE   DrawHlpContextBar; VIRTUAL;
               DESTRUCTOR  Done;
      END;
      PDesktop = ^TDesktop;

      TMenu = OBJECT
            Liste   : PMenuItem;
            CurMenu : PMenuItem;
            Rect    : TRect;
            ScrRect : ^ScrTab;
            ExitCode  : BYTE;
            ScrollObj : ObjectScrolling;
            Palette   : TMenuPalette;
            ImmediateExit : BOOLEAN;
            Ligne     : BYTE;
            Key       : KeyInfo;

            CONSTRUCTOR Init(C1,C2,L1 : BYTE);
            PROCEDURE   NewMenu(MenuName : STRING; KeyW : STRING; Cmd : WORD; St : MenuStatus);
            PROCEDURE   Run; VIRTUAL;
            DESTRUCTOR  Done;
      {PRIVATE}
            PROCEDURE TopOfList;
            PROCEDURE EndOfList;
            PROCEDURE DisableMenu(Cmd : WORD);
            PROCEDURE EnableMenu(Cmd : WORD);
            PROCEDURE DrawDividerLine(X1,X2, Y : BYTE); VIRTUAL;
            PROCEDURE DrawRect; VIRTUAL;
            PROCEDURE NextItem; VIRTUAL;
            PROCEDURE PreviousItem; VIRTUAL;
            PROCEDURE FirstItem;
            PROCEDURE LastItem;
            PROCEDURE CaptureScreen;
            PROCEDURE RestoreScreen;
            PROCEDURE ViewItems; VIRTUAL;
            PROCEDURE ItemSelect; VIRTUAL;
            PROCEDURE ItemUnselect; VIRTUAL;
            PROCEDURE Scroll; VIRTUAL; {Scrolling de base}
      END;
      PMenu = ^TMenu;

      TPullDownMenu = OBJECT
                    Liste   : PMenuItem;
                    CurMenu : PMenuItem;
                    Rect    : TRect;
                    ExitCode  : BYTE;
                    Palette   : TMenuPalette;
                    Col       : BYTE;
                    Key       : KeyInfo;
                    ImmediateExit : BOOLEAN;

                    CONSTRUCTOR Init(C1,C2,L : BYTE);
                    PROCEDURE   NewMenu(MenuName : STRING; Cmd : WORD; St : MenuStatus);
                    DESTRUCTOR  Done;
      {PRIVATE}
                    PROCEDURE TopOfList;
                    PROCEDURE EndOfList;
                    PROCEDURE ChangeStatus;
                    PROCEDURE FirstMenu;
                    PROCEDURE NextItem;
                    PROCEDURE FirstItem;
                    PROCEDURE LastItem;
                    PROCEDURE PreviousItem;
                    PROCEDURE DisableMenu(Cmd : WORD);
                    PROCEDURE EnableMenu(Cmd : WORD);
                    PROCEDURE ViewItems; VIRTUAL;
                    PROCEDURE ItemSelect; VIRTUAL;
                    PROCEDURE ItemUnselect; VIRTUAL;
                    PROCEDURE Scroll; VIRTUAL;
                    PROCEDURE Run; VIRTUAL;
      END;
      PPullDownMenu = ^TPullDownMenu;

      TCheckBoxes = OBJECT
                  Liste  : PCheckBoxItem;
                  CurBox : PCheckBoxItem;
                  Rect   : TRect;
                  ExitCode  : BYTE;
                  ScrollObj : ObjectScrolling;
                  Palette   : TCheckBoxesPalette;
                  ImmediateExit : BOOLEAN;
                  Ligne,Col,MaxLength : BYTE;
                  Key  : KeyInfo;

                  CONSTRUCTOR Init(L1,C1,L2,C2 : BYTE);
                  PROCEDURE   NewBox(BoxName : STRING; Cmd : WORD; St : BoxStatus);
                  PROCEDURE   Run; VIRTUAL;
                  DESTRUCTOR  Done;
      {PRIVATE}
                  PROCEDURE TopOfList;
                  PROCEDURE EndOfList;
                  PROCEDURE NextBox;
                  PROCEDURE PreviousBox;
                  PROCEDURE MarkBox; VIRTUAL;
                  PROCEDURE UnMarkBox; VIRTUAL;
                  PROCEDURE ItemSelect; VIRTUAL;
                  PROCEDURE ItemUnselect; VIRTUAL;
                  PROCEDURE ViewBoxes; VIRTUAL;
                  PROCEDURE Scroll; VIRTUAL;
                  FUNCTION  IsChecked(Cmd : WORD) : BOOLEAN;
      END;
      PCheckBoxes = ^TCheckBoxes;

      TRadioButtons = OBJECT
                  Liste  : PRadioItem;
                  CurRadio : PRadioItem;
                  Rect   : TRect;
                  ExitCode  : BYTE;
                  ScrollObj : ObjectScrolling;
                  Palette   : TRadioPalette;
                  Ligne,Col,MaxLength : BYTE;
                  ImmediateExit : BOOLEAN;
                  Key  : KeyInfo;

                  CONSTRUCTOR Init(L1,C1,L2,C2 : BYTE);
                  PROCEDURE   NewRadio(RadioName : STRING; Cmd : WORD; St : RadioStatus);
                  PROCEDURE   Run; VIRTUAL;
                  DESTRUCTOR  Done;
      {PRIVATE}
                  PROCEDURE TopOfList;
                  PROCEDURE EndOfList;
                  PROCEDURE NextRadio;
                  PROCEDURE PreviousRadio;
                  PROCEDURE MarkRadio; VIRTUAL;
                  PROCEDURE UnMarkRadio; VIRTUAL;
                  PROCEDURE ItemSelect; VIRTUAL;
                  PROCEDURE ItemUnselect; VIRTUAL;
                  PROCEDURE ViewRadios; VIRTUAL;
                  PROCEDURE Scroll; VIRTUAL;
                  FUNCTION  IsChecked(Cmd : WORD) : BOOLEAN;
      END;
      PRadioButtons = ^TRadioButtons;

      TButton = OBJECT
              Liste : PButtonItem;
              CurButton : PButtonItem;
              ExitCode  : BYTE;
              ScrollObj : ObjectScrolling;
              Palette   : TButtonPalette;
              ImmediateExit : BOOLEAN;
              Key  : KeyInfo;

              CONSTRUCTOR Init;
              PROCEDURE   NewButton(ButtonName : STRING; L,C : BYTE; Cmd : WORD; St : ButtonStatus);
              PROCEDURE   Run; VIRTUAL;
              DESTRUCTOR  Done;
      {PRIVATE}
              PROCEDURE TopOfList;
              PROCEDURE EndOfList;
              PROCEDURE NextButton;
              PROCEDURE PreviousButton;
              PROCEDURE FirstButton;
              PROCEDURE LastButton;
              PROCEDURE ItemSelect; VIRTUAL;
              PROCEDURE ItemUnselect; VIRTUAL;
              PROCEDURE ViewButtons; VIRTUAL;
              PROCEDURE Scroll; VIRTUAL;
      END;
      PButton = ^TButton;

      TListeVolets = OBJECT
                   Liste     : PListeItem;
                   NbVolets  : BYTE; {De prfrence > 1; ReadOnly}
                   MaxLength : BYTE; {Taille du plus grand lment; ReadOnly}
                   Rect      : TRect; {Bordures d'affichage; ReadOnly}
                   ExitCode  : BYTE; {Code sortie. Voir CRTPLUS.PAS}
                   ScrollObj : ObjectScrolling; {Va et vient entre objets}
                   Palette   : TListePalette; {Couleurs. Read/Write}
                   Top       : PListeItem; {Premier lment de la partie affiche}
                   Ligne, Col, Volet : BYTE;
                   ListeExitStr : STRING[80]; {Nom de l'lment aprs sortie}
                   Key  : KeyInfo;

                   CONSTRUCTOR Init(L1,C1,L2,C2 : BYTE);
                   PROCEDURE   NewItem(ItemName : STRING);
                   DESTRUCTOR  Done;
      {PRIVATE}
                   PROCEDURE TopOfList;
                   PROCEDURE AdjustItems; VIRTUAL;
                   PROCEDURE VertLine(X1,X2, Colonne : BYTE); VIRTUAL;
                   PROCEDURE ClearVolets; VIRTUAL;
                   PROCEDURE NextItem; VIRTUAL;
                   PROCEDURE PreviousItem; VIRTUAL;
                   PROCEDURE ViewList(Lst : PListeItem); VIRTUAL;
                   PROCEDURE Scroll; VIRTUAL;
                   PROCEDURE Run; VIRTUAL;
      END;

      TListe = OBJECT
             Liste   : PListeItem;
             CurItem : PListeItem;
             Top     : PListeItem;
             Palette : TListePalette;
             ExitCode : BYTE;
             Rect     : TRect;
             ScrollObj : ObjectScrolling;
             ImmediateExit : BOOLEAN;
             Ligne : BYTE;
             Key  : KeyInfo;

             CONSTRUCTOR Init(L1,C1,L2,C2 : BYTE);
             PROCEDURE   NewItem(ItemName : STRING);
             PROCEDURE   Run; VIRTUAL;
             DESTRUCTOR  Done;
      {PRIVATE}
             PROCEDURE TopOfList;
             PROCEDURE EndOfList;
             PROCEDURE NextItem;
             PROCEDURE FirstItem;
             PROCEDURE LastItem;
             PROCEDURE PreviousItem;
             PROCEDURE ItemSelect; VIRTUAL;
             PROCEDURE ItemUnselect; VIRTUAL;
             PROCEDURE ItemImplicite; VIRTUAL;
             PROCEDURE ViewItems; VIRTUAL;
             PROCEDURE Scroll; VIRTUAL;
             PROCEDURE DeleteItem(ItemName : STRING);
      END;
      PListe = ^TListe;

      TPullDownListe = OBJECT
             Liste   : PListeItem;
             CurItem : PListeItem;
             Top     : PListeItem;
             Palette : TPullDownListePalette;
             PullDown : BOOLEAN;
             ExitCode : BYTE;
             Scr      : ^ScrTab;
             Rect : TRect;
             ScrollObj : ObjectScrolling;
             Ligne : BYTE;
             Key  : KeyInfo;

             CONSTRUCTOR Init(L1,C1,L2,C2 : BYTE);
             PROCEDURE   NewItem(ItemName : STRING);
             PROCEDURE   Run; VIRTUAL;
             DESTRUCTOR  Done;
      {PRIVATE}
             PROCEDURE TopOfList;
             PROCEDURE EndOfList;
             PROCEDURE NextItem;
             PROCEDURE PreviousItem;
             PROCEDURE DrawPullDownArrow; VIRTUAL;
             PROCEDURE DrawBorder; VIRTUAL;
             PROCEDURE ItemSelect; VIRTUAL;
             PROCEDURE ItemUnselect; VIRTUAL;
             PROCEDURE FieldSelect; VIRTUAL;
             PROCEDURE FieldUnselect; VIRTUAL;
             PROCEDURE ViewItems; VIRTUAL;
             PROCEDURE Scroll; VIRTUAL;
             PROCEDURE DeleteItem(ItemName : STRING);
      END;
      PPullDownListe = ^TPullDownListe;

      TField = OBJECT
             Liste : PFieldItem;
             CurField : PFieldItem;
             PosCur,PosStr : BYTE;
             ExitCode : BYTE;
             ScrollObj : ObjectScrolling;
             Palette : TFieldPalette;
             Key  : KeyInfo;

             CONSTRUCTOR Init;
             PROCEDURE   NewField(FieldName : STRING; FieldData : STRING; ChF : Chars; Len : BYTE; L,C : BYTE);
             PROCEDURE   Run;
             DESTRUCTOR  Done;
      {PRIVATE}
             PROCEDURE TopOfList;
             PROCEDURE EndOfList;
             PROCEDURE NextField;
             PROCEDURE PreviousField;
             PROCEDURE FirstField;
             PROCEDURE LastField;
             PROCEDURE Assign(FieldData : STRING);
             PROCEDURE Draw; VIRTUAL;
             PROCEDURE ViewFields; VIRTUAL;
             PROCEDURE Input; VIRTUAL;
             FUNCTION  GetData(FieldName : STRING) : STRING;
      END;
      PField = ^TField;

      TWindow = OBJECT
              Liste : PWindowItem;
              CurWindow : PWindowItem;
              Palette : TWindowPalette;
              ScrollObj : ObjectScrolling;
              ExitCode : BYTE;

              CONSTRUCTOR Init;
              PROCEDURE   NewWindow(WindowTitle : STRING; L1,C1,L2,C2 : BYTE; Sh : OnOff);
              PROCEDURE   Run;
              DESTRUCTOR  Done;
      {PRIVATE}
              PROCEDURE TopOfList;
              PROCEDURE EndOfList;
              PROCEDURE NextWindow; VIRTUAL;
              PROCEDURE PreviousWindow; VIRTUAL;
              PROCEDURE DrawActiveTitle; VIRTUAL;
              PROCEDURE DrawPassiveTitle; VIRTUAL;
              PROCEDURE FillWindow; VIRTUAL;
              PROCEDURE WindowSelect; VIRTUAL;
              PROCEDURE WindowUnSelect; VIRTUAL;
              PROCEDURE ViewWindows; VIRTUAL;
      END;
      PWindow = ^TWindow;

      TLabel = OBJECT
             Liste : PLabelItem;
             CurLabel : PLabelItem;
             Palette : TLabelPalette;

             CONSTRUCTOR Init;
             PROCEDURE   NewLabel(LabelName : STRING; L,C : BYTE; Ls : LabelStatus);
             DESTRUCTOR  Done;

             PROCEDURE   TopOfList;
             PROCEDURE   EndOfList;
             PROCEDURE   NextLabel;
             PROCEDURE   FirstLabel;
             PROCEDURE   LastLabel;
             PROCEDURE   PreviousLabel;
             PROCEDURE   GotoLabel(LabelNo : WORD);
             PROCEDURE   LabelSelect; VIRTUAL;
             PROCEDURE   LabelUnselect; VIRTUAL;
             PROCEDURE   ViewLabels; VIRTUAL;
      END;
      PLabel = ^TLabel;

 CONST ExpandSubMenu = 4;

 IMPLEMENTATION

 CONSTRUCTOR TDesktop.Init;
 BEGIN
      DesktopChar:= #176;
      WITH Rect DO BEGIN
           X1:= L1; X2:= L2; Y1:= C1; Y2:= C2;
      END;
      WITH Palette DO BEGIN
           Desktop.X:= 1; Desktop.Y:= 7;
           HlpContext.X:= 00; HlpContext.Y:= 7;
      END;
 END;

 PROCEDURE TDesktop.DrawDesktop;
 VAR I,J : BYTE;
 BEGIN
      TColor(Palette.Desktop.X,Palette.Desktop.Y);
      FOR I:= Rect.X1+1 TO Rect.X2-1 DO FOR J:= Rect.Y1 TO Rect.Y2 DO TWrite(DesktopChar,I,J);
 END;

 PROCEDURE TDesktop.DrawHlpContextBar;
 VAR I : BYTE;
 BEGIN
      TColor(Palette.HlpContext.X,Palette.HlpContext.Y);
      FOR I:= Rect.Y1 TO Rect.Y2 DO TWrite(' ',Rect.X1,I);
      FOR I:= Rect.Y1 TO Rect.Y2 DO TWrite(' ',Rect.X2,I);
 END;

 DESTRUCTOR TDesktop.Done;
 BEGIN
 END;

 CONSTRUCTOR TMenu.Init;
 BEGIN
      Liste:= NIL; ScrollObj:= Inactive; ScrRect:= NIL; CurMenu:= NIL;
      ImmediateExit:= FALSE;
      {New(ScrRect);}
      WITH Rect DO BEGIN
           X1:= L1; X2:= L1+1; Y1:= C1; Y2:= C2;
      END;
      Ligne:= Rect.X1+1;
      WITH Palette DO BEGIN
           Selected.X:= 09; Selected.Y:= 11;
           Unselected.X:= 00; Unselected.Y:= 07;
           DisabledSelected.X:= 07; DisabledSelected.Y:= 08;
           DisabledUnselected.X:= 08; DisabledUnselected.Y:= 07;
           KeyWordSelected.X:= 00; KeyWordSelected.Y:= 11;
           KeyWordUnselected.X:= 14; KeyWordUnselected.Y:= 07;
           KeyWordSelectedDisabled.X:= 07; KeyWordSelectedDisabled.Y:= 08;
           KeyWordUnselectedDisabled.X:= 08; KeyWordUnselectedDisabled.Y:= 07;
           Shortcut.X:= 02; Shortcut.Y:= 11;
      END;
 END;

 PROCEDURE TMenu.CaptureScreen;
 BEGIN
      GetScr(Rect.X1,Rect.Y1,Rect.X2+1,Rect.Y2+2, ScrRect^);
 END;

 PROCEDURE TMenu.RestoreScreen;
 BEGIN
      SetScr(Rect.X1,Rect.Y1,Rect.X2+1,Rect.Y2+2, ScrRect^);
 END;

 PROCEDURE TMenu.TopOfList; {Tte de la liste}
 BEGIN
      WHILE Liste^.Precedent <> NIL DO Liste:= Liste^.Precedent;
 END;

 PROCEDURE TMenu.EndOfList; {Queue de la liste}
 BEGIN
      WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
 END;

 PROCEDURE TMenu.NewMenu; {Nouvel lment}
 VAR Nouveau : PMenuItem;
 BEGIN
      IF ScrRect <> NIL THEN BEGIN
         FreeMem(ScrRect, (Rect.X2-Rect.X1+1+1)*(Rect.Y2-Rect.Y1+1+2)*2);
         ScrRect:= NIL;
      END;
      New(Nouveau);
      IF Liste <> NIL THEN BEGIN
         WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
         Liste^.Suivant:= Nouveau;
         Nouveau^.Name:= MenuName;
         Nouveau^.Status:= St;
         Nouveau^.KeyWord:= KeyW;
         Nouveau^.Command:= Cmd;
         Nouveau^.Suivant:= NIL;
         Nouveau^.Precedent:= Liste;
         Liste:= Liste^.Suivant;
      END ELSE BEGIN
         Liste:= Nouveau;
         Liste^.Name:= MenuName;
         Liste^.Status:= St;
         Liste^.KeyWord:= KeyW;
         Liste^.Command:= Cmd;
         Liste^.Suivant:= NIL;
         Liste^.Precedent:= NIL;
      END;
      IF CurMenu = NIL THEN CurMenu:= Liste;
      Rect.X2:= Rect.X2+1;
      IF ScrRect = NIL THEN BEGIN
         GetMem(ScrRect, (Rect.X2-Rect.X1+1+1)*(Rect.Y2-Rect.Y1+1+2)*2);
      END;
 END;

 PROCEDURE TMenu.DrawDividerLine;
 VAR I : BYTE;
 BEGIN
      TColor(Palette.Unselected.X,Palette.Unselected.Y);
      FOR I:= X1+1 TO X2-1 DO TWrite(#196, Y,I);
 END;

 PROCEDURE TMenu.DrawRect;
 VAR I : BYTE;
 BEGIN
      FOR I:= Rect.X1+1 TO Rect.X2 DO
        TDrawBox(Rect.X1,Rect.Y1,Rect.X2,Rect.Y2, Palette.Unselected.X,Palette.Unselected.Y, On, Single);
 END;

 PROCEDURE TMenu.NextItem;
 BEGIN
      IF CurMenu^.Suivant <> NIL THEN BEGIN
         Ligne:= Ligne+1;
         CurMenu:= CurMenu^.Suivant;
         IF CurMenu^.Name = '' THEN NextItem;
      END ELSE BEGIN
         TopOfList;
         CurMenu:= Liste;
         Ligne:= Rect.X1+1;
         IF CurMenu^.Name = '' THEN NextItem;
      END;
 END;

 PROCEDURE TMenu.PreviousItem;
 BEGIN
      IF CurMenu^.Precedent <> NIL THEN BEGIN
         Ligne:= Ligne-1;
         CurMenu:= CurMenu^.Precedent;
         IF CurMenu^.Name = '' THEN PreviousItem;
      END ELSE BEGIN
         EndOfList;
         CurMenu:= Liste;
         Ligne:= Rect.X2-1;
         IF CurMenu^.Name = '' THEN PreviousItem;
      END;
 END;

 PROCEDURE TMenu.FirstItem;
 BEGIN
      TopOfList;
      CurMenu:= Liste; Ligne:= Rect.X1+1;
      IF CurMenu^.Name = '' THEN NextItem;
 END;

 PROCEDURE TMenu.LastItem;
 BEGIN
      EndOfList;
      CurMenu:= Liste; Ligne:= Rect.X2-1;
      IF CurMenu^.Name = '' THEN PreviousItem;
 END;

 PROCEDURE TMenu.DisableMenu;
 BEGIN
      TopOfList;
      WHILE (Liste^.Command <> Cmd) AND (Liste^.Suivant <> NIL) DO Liste:= Liste^.Suivant;
      IF Liste^.Command = Cmd THEN Liste^.Status:= DisabledMenu;
 END;

 PROCEDURE TMenu.EnableMenu;
 BEGIN
      TopOfList;
      WHILE (Liste^.Command <> Cmd) AND (Liste^.Suivant <> NIL) DO Liste:= Liste^.Suivant;
      IF Liste^.Command = Cmd THEN Liste^.Status:= NormalMenu;
 END;

 PROCEDURE TMenu.ViewItems;
 VAR L,I : BYTE;
 BEGIN
      DrawRect;
      TopOfList;
      L:= Rect.X1+1;
      WHILE Liste <> NIL DO BEGIN
            IF Liste^.Status = NormalMenu THEN TColor(Palette.Unselected.X,Palette.Unselected.Y)
              ELSE TColor(Palette.DisabledUnselected.X,Palette.DisabledUnselected.Y);

            TMkSpace(Rect.Y1+1,Rect.Y2-1, L);

            IF Liste^.Name <> '' THEN TWrite(Copy(Liste^.Name,1,Rect.Y2-Rect.Y1-1), L,Rect.Y1+2)
              ELSE DrawDividerLine(Rect.Y1,Rect.Y2, L);

            IF Liste^.Status = NormalMenu THEN TColor(Palette.KeyWordUnselected.X,Palette.KeyWordUnselected.Y)
              ELSE TColor(Palette.KeyWordUnselectedDisabled.X,Palette.KeyWordUnselectedDisabled.Y);
            TWrite(Liste^.KeyWord, L,Rect.Y2-1-Length(Liste^.KeyWord));

            L:= L+1;
            IF L > Rect.X2-1 THEN Break;
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
      END;
 END;

 PROCEDURE TMenu.ItemSelect;
 BEGIN
      IF CurMenu^.Status = DisabledMenu THEN TColor(Palette.DisabledSelected.X,Palette.DisabledSelected.Y)
        ELSE TColor(Palette.Selected.X,Palette.Selected.Y);

      TMkSpace(Rect.Y1+1,Rect.Y2-1, Ligne);
      TWrite(Copy(CurMenu^.Name,1,Rect.Y2-Rect.Y1-1), Ligne,Rect.Y1+2);

      IF CurMenu^.Status = NormalMenu THEN TColor(Palette.KeyWordSelected.X,Palette.KeyWordSelected.Y)
        ELSE TColor(Palette.KeyWordSelectedDisabled.X,Palette.KeyWordSelectedDisabled.Y);
      TWrite(CurMenu^.KeyWord, Ligne,Rect.Y2-1-Length(CurMenu^.KeyWord));
 END;

 PROCEDURE TMenu.ItemUnselect;
 BEGIN
      IF CurMenu^.Status = DisabledMenu THEN TColor(Palette.DisabledUnselected.X,Palette.DisabledUnselected.Y)
        ELSE TColor(Palette.Unselected.X,Palette.Unselected.Y);

      TMkSpace(Rect.Y1+1,Rect.Y2-1, Ligne);
      TWrite(Copy(CurMenu^.Name,1,Rect.Y2-Rect.Y1-1), Ligne,Rect.Y1+2);

      IF CurMenu^.Status = NormalMenu THEN TColor(Palette.KeyWordUnselected.X,Palette.KeyWordUnselected.Y)
        ELSE TColor(Palette.KeyWordUnselectedDisabled.X,Palette.KeyWordUnselectedDisabled.Y);
      TWrite(CurMenu^.KeyWord, Ligne,Rect.Y2-1-Length(CurMenu^.KeyWord));
 END;

 PROCEDURE TMenu.Scroll;
 BEGIN
      ExitCode:= 255;
      Key.Name:= '';
      WHILE (Key.Name <> 'ENTER') AND (Key.Name <> 'ESC') DO BEGIN
            ItemSelect;
            GetKey(Key);

            IF Copy(Key.Name,1,4) = 'GRAY' THEN ItemUnselect;

            IF Key.Name = 'GRAY DOWN' THEN NextItem;

            IF Key.Name = 'GRAY UP' THEN PreviousItem;

            IF Key.Name = 'GRAY HOME' THEN BEGIN
               TopOfList;
               Ligne:= Rect.X1+1;
               CurMenu:= Liste;
               IF CurMenu^.Name = '' THEN NextItem;
            END;

            IF Key.Name = 'GRAY END' THEN BEGIN
               EndOfList;
               Ligne:= Rect.X2-1;
               CurMenu:= Liste;
               IF CurMenu^.Name = '' THEN PreviousItem;
            END;

            IF (Key.Name = 'GRAY LEFT') AND (ScrollObj = Active) THEN BEGIN
               ExitCode:= Precedent;
               Break;
            END;

            IF (Key.Name = 'GRAY RIGHT') AND (ScrollObj = Active) THEN BEGIN
               ExitCode:= Next;
               Break;
            END;

            IF (Key.Name = 'TAB') AND (ScrollObj = Active) THEN BEGIN
               ExitCode:= Next;
               Break;
            END;

            IF (Key.Name = 'SHIFT+TAB') AND (ScrollObj = Active) THEN BEGIN
               ExitCode:= Precedent;
               Break;
            END;

            IF (Key.Name = 'ENTER') AND (CurMenu^.Status = DisabledMenu) THEN Key.Name:= '';

            IF ImmediateExit THEN Break;
      END;

      IF Key.Name = 'ENTER' THEN ExitCode:= Ok;
      IF Key.Name = 'ESC' THEN ExitCode:= Cancel;
 END;

 DESTRUCTOR TMenu.Done;
 VAR Cur : PMenuItem;
 BEGIN
      TopOfList;
      WHILE Liste^.Suivant <> NIL DO BEGIN
            Cur:= Liste;
            Dispose(Cur);
            Cur:= NIL;
            Liste:= Liste^.Suivant;
      END;
      Cur:= Liste;
      Dispose(Cur);
      Liste:= NIL;

      IF ScrRect <> NIL THEN FreeMem(ScrRect, (Rect.X2-Rect.X1+1+1)*(Rect.Y2-Rect.Y1+1+2)*2);
 END;

 PROCEDURE TMenu.Run;
 BEGIN
      TopOfList;
      IF CurMenu^.Name = '' THEN NextItem;
      CaptureScreen;
      ViewItems;
      Scroll;
      RestoreScreen;
 END;

 {****************}

 CONSTRUCTOR TPullDownMenu.Init;
 BEGIN
      Liste:= NIL; CurMenu:= NIL; ImmediateExit:= FALSE;
      WITH Rect DO BEGIN
           X1:= L; X2:= 00; Y1:= C1; Y2:= Y1+1;
      END;
      Col:= Rect.Y1+1;
      WITH Palette DO BEGIN
           Selected.X:= 00; Selected.Y:= 14;
           Unselected.X:= 00; Unselected.Y:= 07;
           DisabledSelected.X:= 07; DisabledSelected.Y:= 08;
           DisabledUnselected.X:= 08; DisabledUnselected.Y:= 07;
           KeyWordSelected.X:= 00; KeyWordSelected.Y:= 11;
           KeyWordUnselected.X:= 14; KeyWordUnselected.Y:= 07;
           KeyWordSelectedDisabled.X:= 07; KeyWordSelectedDisabled.Y:= 08;
           KeyWordUnselectedDisabled.X:= 08; KeyWordUnselectedDisabled.Y:= 07;
           Shortcut.X:= 02; Shortcut.Y:= 11;
      END;
 END;

 PROCEDURE TPullDownMenu.NewMenu; {Nouvel lment}
 VAR Nouveau : PMenuItem;
 BEGIN
      New(Nouveau);
      IF Liste <> NIL THEN BEGIN
         WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
         Liste^.Suivant:= Nouveau;
         Nouveau^.Name:= MenuName;
         Nouveau^.Status:= St;
         Nouveau^.KeyWord:= '';
         Nouveau^.Command:= Cmd;
         Nouveau^.Suivant:= NIL;
         Nouveau^.Precedent:= Liste;
         Liste:= Liste^.Suivant;
      END ELSE BEGIN
         Liste:= Nouveau;
         Liste^.Name:= MenuName;
         Liste^.Status:= St;
         Liste^.KeyWord:= '';
         Liste^.Command:= Cmd;
         Liste^.Suivant:= NIL;
         Liste^.Precedent:= NIL;
      END;
      IF CurMenu = NIL THEN CurMenu:= Liste;
      Rect.Y2:= Rect.Y2+Length(Liste^.Name);
 END;

 PROCEDURE TPullDownMenu.FirstMenu;
 BEGIN
      TopOfList; CurMenu:= Liste; Col:= Rect.Y1+1;
 END;

 PROCEDURE TPullDownMenu.NextItem;
 BEGIN
      IF CurMenu^.Suivant <> NIL THEN BEGIN
         Col:= Col+Length(CurMenu^.Name);
         CurMenu:= CurMenu^.Suivant;
      END ELSE BEGIN
         TopOfList;
         CurMenu:= Liste;
         Col:= Rect.Y1+1;
      END;
 END;

 PROCEDURE TPullDownMenu.PreviousItem;
 BEGIN
      IF CurMenu^.Precedent <> NIL THEN BEGIN
         CurMenu:= CurMenu^.Precedent;
         Col:= Col-Length(CurMenu^.Name);
      END ELSE BEGIN
         EndOfList;
         CurMenu:= Liste;
         Col:= Rect.Y2-Length(CurMenu^.Name);
      END;
 END;

 PROCEDURE TPullDownMenu.FirstItem;
 BEGIN
      WHILE CurMenu^.Precedent <> NIL DO PreviousItem;
 END;

 PROCEDURE TPullDownMenu.LastItem;
 BEGIN
      WHILE CurMenu^.Suivant <> NIL DO NextItem;
 END;

 PROCEDURE TPullDownMenu.TopOfList; {Tte de la liste}
 BEGIN
      WHILE Liste^.Precedent <> NIL DO Liste:= Liste^.Precedent;
 END;

 PROCEDURE TPullDownMenu.EndOfList; {Queue de la liste}
 BEGIN
      WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
 END;

 PROCEDURE TPullDownMenu.DisableMenu;
 BEGIN
      TopOfList;
      WHILE (Liste^.Command <> Cmd) AND (Liste^.Suivant <> NIL) DO Liste:= Liste^.Suivant;
      IF Liste^.Command = Cmd THEN Liste^.Status:= DisabledMenu;
 END;

 PROCEDURE TPullDownMenu.EnableMenu;
 BEGIN
      TopOfList;
      WHILE (Liste^.Command <> Cmd) AND (Liste^.Suivant <> NIL) DO Liste:= Liste^.Suivant;
      IF Liste^.Command = Cmd THEN Liste^.Status:= NormalMenu;
 END;

 PROCEDURE TPullDownMenu.ChangeStatus;
 BEGIN
      IF CurMenu^.Status = NormalMenu THEN CurMenu^.Status:= DisabledMenu ELSE CurMenu^.Status:= NormalMenu;
 END;

 PROCEDURE TPullDownMenu.ItemSelect;
 BEGIN
      IF CurMenu^.Status = DisabledMenu THEN TColor(Palette.DisabledSelected.X,Palette.DisabledSelected.Y)
        ELSE TColor(Palette.Selected.X,Palette.Selected.Y);
      TWrite(CurMenu^.Name, Rect.X1,Col);
 END;

 PROCEDURE TPullDownMenu.ItemUnselect;
 BEGIN
      IF CurMenu^.Status = DisabledMenu THEN TColor(Palette.DisabledUnselected.X,Palette.DisabledUnselected.Y)
        ELSE TColor(Palette.Unselected.X,Palette.Unselected.Y);
      TWrite(CurMenu^.Name, Rect.X1,Col);
 END;

 PROCEDURE TPullDownMenu.ViewItems;
 VAR C : BYTE;
 BEGIN
      TopOfList; C:= Rect.Y1+1;
      WHILE Liste <> NIL DO BEGIN
            IF Liste^.Status = NormalMenu THEN TColor(Palette.Unselected.X,Palette.Unselected.Y)
              ELSE TColor(Palette.DisabledUnselected.X,Palette.DisabledUnselected.Y);
            TWrite(Liste^.Name, Rect.X1,C);
            C:= C+Length(Liste^.Name);
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
      END;
 END;

 PROCEDURE TPullDownMenu.Scroll;
 BEGIN
      ExitCode:= 255;
      Key.Name:= '';
      WHILE (Key.Name <> 'ENTER') AND (Key.Name <> 'ESC') DO BEGIN
            ItemSelect;
            GetKey(Key);

            IF Copy(Key.Name,1,4) = 'GRAY' THEN ItemUnselect;

            IF Key.Name = 'GRAY RIGHT' THEN NextItem;

            IF Key.Name = 'GRAY LEFT' THEN PreviousItem;

            IF Key.Name = 'GRAY HOME' THEN BEGIN
               TopOfList;
               Col:= Rect.Y1+1;
               CurMenu:= Liste;
            END;

            IF Key.Name = 'GRAY END' THEN BEGIN
               EndOfList;
               Col:= Rect.Y2-Length(Liste^.Name);
               CurMenu:= Liste;
            END;

            IF (Key.Name = 'GRAY DOWN') AND (CurMenu^.Status <> DisabledMenu) THEN BEGIN
               ExitCode:= Ok;
               ItemSelect;
               Break;
            END;

            IF (Key.Name = 'ENTER') AND (CurMenu^.Status = DisabledMenu) THEN Key.Name:= '';

            IF ImmediateExit THEN Break;
      END;

      IF Key.Name = 'ENTER' THEN ExitCode:= Ok;
      IF Key.Name = 'ESC' THEN ExitCode:= Cancel;
 END;

 PROCEDURE TPullDownMenu.Run;
 BEGIN
      ViewItems;
      Scroll;
 END;


 DESTRUCTOR TPullDownMenu.Done;
 VAR Cur : PMenuItem;
 BEGIN
      TopOfList;
      WHILE Liste^.Suivant <> NIL DO BEGIN
            Cur:= Liste;
            Dispose(Cur);
            Cur:= NIL;
            Liste:= Liste^.Suivant;
      END;
      Cur:= Liste;
      Dispose(Cur);
      Liste:= NIL;
 END;

 {************}

 CONSTRUCTOR TCheckBoxes.Init;
 BEGIN
      Liste:= NIL; CurBox:= NIL; ScrollObj:= Inactive; ImmediateExit:= FALSE;
      WITH Rect DO BEGIN
           X1:= L1; Y1:= C1; Y2:= C2; X2:= L2;
      END;
      Ligne:= Rect.X1; Col:= Rect.Y1+1; MaxLength:= 0;

      WITH Palette DO BEGIN
           Selected.X:= 14; Selected.Y:= 3;
           Unselected.X:= 15; Unselected.Y:= 3;
           Disabled.X:= 8; Disabled.Y:= 3;
           BoxChecked.X:= 14; BoxChecked.Y:= 3;
           BoxUnChecked.X:= 15; BoxUnChecked.Y:= 3;
      END;
 END;

 PROCEDURE TCheckBoxes.NewBox;
 VAR Nouveau : PCheckBoxItem;
 BEGIN
      New(Nouveau);
      IF Liste <> NIL THEN BEGIN
         WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
         Liste^.Suivant:= Nouveau;
         Nouveau^.Name:= BoxName;
         Nouveau^.Status:= St;
         Nouveau^.Command:= Cmd;
         Nouveau^.Suivant:= NIL;
         Nouveau^.Precedent:= Liste;
         Liste:= Liste^.Suivant;
      END ELSE BEGIN
         Liste:= Nouveau;
         Liste^.Name:= BoxName;
         Liste^.Status:= St;
         Liste^.Command:= Cmd;
         Liste^.Suivant:= NIL;
         Liste^.Precedent:= NIL;
      END;
      IF CurBox = NIL THEN CurBox:= Liste;
      IF Length(Liste^.Name) > MaxLength THEN MaxLength:= Length(Liste^.Name);
 END;

 PROCEDURE TCheckBoxes.TopOfList; {Tte de la liste}
 BEGIN
      WHILE Liste^.Precedent <> NIL DO Liste:= Liste^.Precedent;
 END;

 PROCEDURE TCheckBoxes.EndOfList; {Queue de la liste}
 BEGIN
      WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
 END;

 PROCEDURE TCheckBoxes.NextBox;
 BEGIN
      IF CurBox^.Suivant <> NIL THEN BEGIN
         CurBox:= CurBox^.Suivant;
         Ligne:= Ligne+1;
         IF Ligne > Rect.X2 THEN BEGIN
            Ligne:= Rect.X1;
            Col:= Col+MaxLength+3+2;
         END;
         IF CurBox^.Status = UnavailableBox THEN NextBox;
     END ELSE BEGIN
            TopOfList;
            CurBox:= Liste;
            Ligne:= Rect.X1;
            Col:= Rect.Y1+1;
            IF CurBox^.Status = UnavailableBox THEN NextBox;
      END;
 END;

 PROCEDURE TCheckBoxes.PreviousBox;
 BEGIN
      IF CurBox^.Precedent <> NIL THEN BEGIN
         CurBox:= CurBox^.Precedent;
         Ligne:= Ligne-1;
         IF Ligne < Rect.X1 THEN BEGIN
            Ligne:= Rect.X2;
            Col:= Col-MaxLength-3-2;
         END;
         IF CurBox^.Status = UnavailableBox THEN PreviousBox;
      END ELSE BEGIN
         WHILE CurBox^.Suivant <> NIL DO BEGIN
               Ligne:= Ligne+1;
               CurBox:= CurBox^.Suivant;
               IF Ligne > Rect.X2 THEN BEGIN
                  Ligne:= Rect.X1;
                  Col:= Col+MaxLength+3+2;
               END;
         END;
         IF CurBox^.Status = UnavailableBox THEN PreviousBox;
      END;
 END;

 PROCEDURE TCheckBoxes.MarkBox;
 BEGIN
      TColor(Palette.BoxChecked.X,Palette.BoxChecked.Y);
      TWrite(#228#229,Ligne,Col);
 END;

 PROCEDURE TCheckBoxes.UnMarkBox;
 BEGIN
      TColor(Palette.BoxUnchecked.X,Palette.BoxUnchecked.Y);
      TWrite(#230#231,Ligne,Col);
 END;

 PROCEDURE TCheckBoxes.ItemSelect;
 BEGIN
      TColor(Palette.Selected.X,Palette.Selected.Y);
      TWrite(CurBox^.Name,Ligne,Col+3);
 END;

 PROCEDURE TCheckBoxes.ItemUnSelect;
 BEGIN
      TColor(Palette.Unselected.X,Palette.Unselected.Y);
      TWrite(CurBox^.Name,Ligne,Col+3);
 END;

 PROCEDURE TCheckBoxes.ViewBoxes;
 VAR L,C : BYTE;
 BEGIN
      TDrawBox(Rect.X1,Rect.Y1,Rect.X2,Rect.Y2, 0,Palette.Unselected.Y, Off, NoBorder);
      TopOfList;
      L:= Ligne; C:= Col;
      Ligne:= Rect.X1; Col:= Rect.Y1+1;
      WHILE Liste <> NIL DO BEGIN
            IF Liste^.Status <> UnavailableBox THEN TColor(Palette.Unselected.X,Palette.Unselected.Y)
              ELSE TColor(Palette.Disabled.X,Palette.Disabled.Y);
            TWrite(Liste^.Name, Ligne,Col+3);
            IF Liste^.Status = CheckedBox THEN MarkBox ELSE UnMarkBox;
            Ligne:= Ligne+1;
            IF Ligne > Rect.X2 THEN BEGIN
               Ligne:= Rect.X1; Col:= Col+MaxLength+3+2;
            END;
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
      END;
      Ligne:= L; Col:= C;
 END;

 PROCEDURE TCheckBoxes.Scroll;
 BEGIN
      ExitCode:= 255;
      Key.Name:= '';
      WHILE (Key.Name <> 'ESC') AND (Key.Name <> 'ENTER') DO BEGIN
            ItemSelect;

            GetKey(Key);
            IF Copy(Key.Name,1,4) = 'GRAY' THEN ItemUnselect;

            IF Key.Name = 'GRAY UP' THEN PreviousBox;
            IF Key.Name = 'GRAY DOWN' THEN NextBox;
            IF Key.Name = 'SPACE' THEN IF CurBox^.Status = CheckedBox THEN BEGIN
               UnMarkBox;
               CurBox^.Status:= UnCheckedBox;
            END ELSE BEGIN
               MarkBox;
               CurBox^.Status:= CheckedBox;
            END;

            IF (Key.Name = 'TAB') AND (ScrollObj = Active) THEN BEGIN
               ExitCode:= Next;
               Break;
            END;

            IF (Key.Name = 'SHIFT+TAB') AND (ScrollObj = Active) THEN BEGIN
               ExitCode:= Precedent;
               Break;
            END;

            IF ImmediateExit THEN Break;
      END;
      IF Key.Name = 'ENTER' THEN ExitCode:= Ok;
      IF Key.Name = 'ESC' THEN ExitCode:= Cancel;
      ItemUnselect;
 END;

 PROCEDURE TCheckBoxes.Run;
 BEGIN
      ViewBoxes;
      IF CurBox^.Status = UnavailableBox THEN NextBox;
      Scroll;
 END;

 FUNCTION TCheckBoxes.IsChecked;
 BEGIN
      IsChecked:= FALSE;
      TopOfList;
      WHILE Liste <> NIL DO BEGIN
            IF (Cmd = Liste^.Command) AND (Liste^.Status = CheckedBox) THEN BEGIN
               IsChecked:= TRUE;
               Break;
            END;
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
      END;
 END;

 DESTRUCTOR TCheckBoxes.Done;
 VAR Cur : PCheckBoxItem;
 BEGIN
      TopOfList;
      WHILE Liste^.Suivant <> NIL DO BEGIN
            Cur:= Liste;
            Dispose(Cur);
            Cur:= NIL;
            Liste:= Liste^.Suivant;
      END;
      Cur:= Liste;
      Dispose(Cur);
      Liste:= NIL;
 END;

 {**************}

 CONSTRUCTOR TRadioButtons.Init;
 BEGIN
      Liste:= NIL; CurRadio:= NIL; ScrollObj:= Inactive; ImmediateExit:= FALSE;
      WITH Rect DO BEGIN
           X1:= L1; Y1:= C1; Y2:= C2; X2:= L2;
      END;
      Ligne:= Rect.X1; Col:= Rect.Y1+1; MaxLength:= 0;

      WITH Palette DO BEGIN
           Selected.X:= 14; Selected.Y:= 3;
           Unselected.X:= 15; Unselected.Y:= 3;
           RadioChecked.X:= 10; RadioChecked.Y:= 3;
           RadioUnChecked.X:= 15; RadioUnChecked.Y:= 3;
      END;
 END;

 PROCEDURE TRadioButtons.NewRadio;
 VAR Nouveau : PRadioItem;
 BEGIN
      New(Nouveau);
      IF Liste <> NIL THEN BEGIN
         WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
         Liste^.Suivant:= Nouveau;
         Nouveau^.Name:= RadioName;
         Nouveau^.Status:= St;
         Nouveau^.Command:= Cmd;
         Nouveau^.Suivant:= NIL;
         Nouveau^.Precedent:= Liste;
         Liste:= Liste^.Suivant;
      END ELSE BEGIN
         Liste:= Nouveau;
         Liste^.Name:= RadioName;
         Liste^.Status:= St;
         Liste^.Command:= Cmd;
         Liste^.Suivant:= NIL;
         Liste^.Precedent:= NIL;
      END;
      {IF CurRadio = NIL THEN CurRadio:= Liste;}
      IF Length(Liste^.Name) > MaxLength THEN MaxLength:= Length(Liste^.Name);
 END;

 PROCEDURE TRadioButtons.TopOfList; {Tte de la liste}
 BEGIN
      WHILE Liste^.Precedent <> NIL DO Liste:= Liste^.Precedent;
 END;

 PROCEDURE TRadioButtons.EndOfList; {Queue de la liste}
 BEGIN
      WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
 END;

 PROCEDURE TRadioButtons.NextRadio;
 BEGIN
      IF CurRadio^.Suivant <> NIL THEN BEGIN
         CurRadio:= CurRadio^.Suivant;
         Ligne:= Ligne+1;
         IF Ligne > Rect.X2 THEN BEGIN
            Ligne:= Rect.X1;
            Col:= Col+MaxLength+3+2;
         END;
     END ELSE BEGIN
            TopOfList;
            CurRadio:= Liste;
            Ligne:= Rect.X1;
            Col:= Rect.Y1+1;
      END;
 END;

 PROCEDURE TRadioButtons.PreviousRadio;
 BEGIN
      IF CurRadio^.Precedent <> NIL THEN BEGIN
         CurRadio:= CurRadio^.Precedent;
         Ligne:= Ligne-1;
         IF Ligne < Rect.X1 THEN BEGIN
            Ligne:= Rect.X2;
            Col:= Col-MaxLength-3-2;
         END;
      END ELSE BEGIN
         WHILE CurRadio^.Suivant <> NIL DO BEGIN
               Ligne:= Ligne+1;
               CurRadio:= CurRadio^.Suivant;
               IF Ligne > Rect.X2 THEN BEGIN
                  Ligne:= Rect.X1;
                  Col:= Col+MaxLength+3+2;
               END;
         END;
      END;
 END;

 PROCEDURE TRadioButtons.MarkRadio;
 BEGIN
      TColor(Palette.RadioChecked.X,Palette.RadioChecked.Y);
      TWrite(#224#225,Ligne,Col);
 END;

 PROCEDURE TRadioButtons.UnMarkRadio;
 BEGIN
      TColor(Palette.RadioUnchecked.X,Palette.RadioUnchecked.Y);
      TWrite(#226#227,Ligne,Col);
 END;

 PROCEDURE TRadioButtons.ItemSelect;
 BEGIN
      TColor(Palette.Selected.X,Palette.Selected.Y);
      TWrite(CurRadio^.Name,Ligne,Col+3);
      {SetCursorSize(15,16);
      SetCursorPos(Ligne,Col+2);}
 END;

 PROCEDURE TRadioButtons.ItemUnSelect;
 BEGIN
      TColor(Palette.Unselected.X,Palette.Unselected.Y);
      TWrite(CurRadio^.Name,Ligne,Col+3);
 END;

 PROCEDURE TRadioButtons.ViewRadios;
 VAR L,C : BYTE;
 BEGIN
      TDrawBox(Rect.X1,Rect.Y1,Rect.X2,Rect.Y2, 0,Palette.Unselected.Y, Off, NoBorder);
      Ligne:= Rect.X1; Col:= Rect.Y1+1;

      TopOfList;
      WHILE Liste <> NIL DO BEGIN {Pointe sur l'lement "choisi"}
            IF Liste^.Status = CheckedRadio THEN BEGIN
               CurRadio:= Liste;
               Break;
            END;
            Ligne:= Ligne+1;
            IF Ligne > Rect.X2 THEN BEGIN
               Ligne:= Rect.X1;
               Col:= Col+MaxLength+3+2;
            END;
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
      END;

      TopOfList;
      L:= Ligne; C:= Col;
      Ligne:= Rect.X1; Col:= Rect.Y1+1;
      WHILE Liste <> NIL DO BEGIN
            TColor(Palette.Unselected.X,Palette.Unselected.Y);
            TWrite(Liste^.Name, Ligne,Col+3);
            IF Liste^.Status = CheckedRadio THEN MarkRadio ELSE UnMarkRadio;
            Ligne:= Ligne+1;
            IF Ligne > Rect.X2 THEN BEGIN
               Ligne:= Rect.X1; Col:= Col+MaxLength+3+2;
            END;
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
      END;
      Ligne:= L; Col:= C;
 END;

 PROCEDURE TRadioButtons.Scroll;
 BEGIN
      Key.Name:= ''; ExitCode:= 255;
      Ligne:= Rect.X1; Col:= Rect.Y1+1;
      TopOfList;
      WHILE Liste <> NIL DO BEGIN {Pointe sur l'lement "choisi"}
            IF Liste^.Status = CheckedRadio THEN BEGIN
               CurRadio:= Liste;
               Break;
            END;
            Ligne:= Ligne+1;
            IF Ligne > Rect.X2 THEN BEGIN
               Ligne:= Rect.X1;
               Col:= Col+MaxLength+3+2;
            END;
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
      END;

      WHILE (Key.Name <> 'ESC') AND (Key.Name <> 'ENTER') DO BEGIN
            ItemSelect;
            MarkRadio;
            CurRadio^.Status:= CheckedRadio;

            GetKey(Key);
            IF Copy(Key.Name,1,4) = 'GRAY' THEN BEGIN
               ItemUnselect;
               UnMarkRadio;
               CurRadio^.Status:= UnCheckedRadio;
            END;

            IF Key.Name = 'GRAY UP' THEN PreviousRadio;
            IF Key.Name = 'GRAY DOWN' THEN NextRadio;

            IF (Key.Name = 'TAB') AND (ScrollObj = Active) THEN BEGIN
               ExitCode:= Next;
               Break;
            END;

            IF (Key.Name = 'SHIFT+TAB') AND (ScrollObj = Active) THEN BEGIN
               ExitCode:= Precedent;
               Break;
            END;
            CurRadio^.Status:= CheckedRadio;

            IF ImmediateExit THEN Break;
      END;
      IF Key.Name = 'ENTER' THEN ExitCode:= Ok;
      IF Key.Name = 'ESC' THEN ExitCode:= Cancel;
      ItemUnselect;
 END;

 PROCEDURE TRadioButtons.Run;
 BEGIN
      ViewRadios;
      Scroll;
      HideCursor;
 END;

 FUNCTION TRadioButtons.IsChecked;
 BEGIN
      IsChecked:= FALSE;
      TopOfList;
      WHILE Liste <> NIL DO BEGIN
            IF (Cmd = Liste^.Command) AND (Liste^.Status = CheckedRadio) THEN BEGIN
               IsChecked:= TRUE;
               Break;
            END;
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
      END;
 END;

 DESTRUCTOR TRadioButtons.Done;
 VAR Cur : PRadioItem;
 BEGIN
      TopOfList;
      WHILE Liste^.Suivant <> NIL DO BEGIN
            Cur:= Liste;
            Dispose(Cur);
            Cur:= NIL;
            Liste:= Liste^.Suivant;
      END;
      Cur:= Liste;
      Dispose(Cur);
      Liste:= NIL;
 END;

 {************}

 CONSTRUCTOR TButton.Init;
 BEGIN
      Liste:= NIL; CurButton:= NIL; ScrollObj:= Inactive; ImmediateExit:= FALSE;
      WITH Palette DO BEGIN
           Default.X:= 09; Default.Y:= 15;
           Selected.X:= 00; Selected.Y:= 10;
           Unselected.X:= 0; Unselected.Y:= 15;
           Disabled.X:= 7; Disabled.Y:= 8;
      END;
 END;

 PROCEDURE TButton.NewButton;
 VAR Nouveau : PButtonItem;
 BEGIN
      New(Nouveau);
      IF Liste <> NIL THEN BEGIN
         WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
         Liste^.Suivant:= Nouveau;
         Nouveau^.Name:= ButtonName;
         Nouveau^.Status:= St;
         Nouveau^.Command:= Cmd;
         Nouveau^.Ligne:= L;
         Nouveau^.Col:= C;
         Nouveau^.Suivant:= NIL;
         Nouveau^.Precedent:= Liste;
         Liste:= Liste^.Suivant;
      END ELSE BEGIN
         Liste:= Nouveau;
         Liste^.Name:= ButtonName;
         Liste^.Status:= St;
         Liste^.Command:= Cmd;
         Liste^.Ligne:= L;
         Liste^.Col:= C;
         Liste^.Suivant:= NIL;
         Liste^.Precedent:= NIL;
      END;
      IF CurButton = NIL THEN CurButton:= Liste;
 END;

 PROCEDURE TButton.TopOfList; {Tte de la liste}
 BEGIN
      WHILE Liste^.Precedent <> NIL DO Liste:= Liste^.Precedent;
 END;

 PROCEDURE TButton.EndOfList; {Queue de la liste}
 BEGIN
      WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
 END;

 PROCEDURE TButton.FirstButton;
 BEGIN
      WHILE CurButton^.Precedent <> NIL DO BEGIN
            CurButton:= CurButton^.Precedent;
      END;
      IF CurButton^.Status = DisabledButton THEN NextButton;
 END;

 PROCEDURE TButton.LastButton;
 BEGIN
      WHILE CurButton^.Suivant <> NIL DO BEGIN
            CurButton:= CurButton^.Suivant;
      END;
      IF CurButton^.Status = DisabledButton THEN PreviousButton;
 END;

 PROCEDURE TButton.NextButton;
 BEGIN
      IF CurButton^.Suivant <> NIL THEN BEGIN
         CurButton:= CurButton^.Suivant;
         IF CurButton^.Status = DisabledButton THEN NextButton;
      END ELSE BEGIN
         TopOfList;
         CurButton:= Liste;
         IF CurButton^.Status = DisabledButton THEN NextButton;
      END;
 END;

 PROCEDURE TButton.PreviousButton;
 BEGIN
      IF CurButton^.Precedent <> NIL THEN BEGIN
         CurButton:= CurButton^.Precedent;
         IF CurButton^.Status = DisabledButton THEN PreviousButton;
      END ELSE BEGIN
         EndOfList;
         CurButton:= Liste;
         IF CurButton^.Status = DisabledButton THEN PreviousButton;
      END;
 END;

 PROCEDURE TButton.ItemSelect;
 BEGIN
      TColor(Palette.Selected.X,Palette.Selected.Y);
      TWrite(CurButton^.Name, CurButton^.Ligne, CurButton^.Col);
 END;

 PROCEDURE TButton.ItemUnselect;
 BEGIN
      IF CurButton^.Status = NormalButton THEN
        TColor(Palette.UnSelected.X,Palette.UnSelected.Y) ELSE
        TColor(Palette.Default.X,Palette.Default.Y);
      TWrite(CurButton^.Name, CurButton^.Ligne, CurButton^.Col);
 END;

 PROCEDURE TButton.ViewButtons;
 VAR I : BYTE;
 BEGIN
      TopOfList;
      WHILE Liste <> NIL DO BEGIN
            CASE Liste^.Status OF
                 DisabledButton : TColor(Palette.Disabled.X,Palette.Disabled.Y);
                 NormalButton   : TColor(Palette.Unselected.X,Palette.Unselected.Y);
                 DefaultButton  : TColor(Palette.Default.X,Palette.Default.Y);
            END;
            TWrite(Liste^.Name, Liste^.Ligne, Liste^.Col);

            FOR I:= Liste^.Col+1 TO Liste^.Col+Length(Liste^.Name) DO BEGIN
                TColor(0,GetCharBackground(GetCharAttr(Liste^.Ligne+1,I)));
                TWrite(#223,Liste^.Ligne+1,I);
            END;
            TWrite(#220, Liste^.Ligne,I);
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
      END;
 END;

 PROCEDURE TButton.Scroll;
 BEGIN
      ExitCode:= 255;
      Key.Name:= '';
      WHILE (Key.Name <> 'ESC') AND (Key.Name <> 'ENTER') DO BEGIN
            ItemSelect;
            GetKey(Key);
            ItemUnselect;

            IF (Key.Name = 'TAB') THEN
              IF (CurButton^.Suivant = NIL) AND (ScrollObj = Active) THEN BEGIN
                 ExitCode:= Next;
                 Break;
            END ELSE NextButton;

            IF (Key.Name = 'SHIFT+TAB') THEN
              IF (CurButton^.Precedent = NIL) AND (ScrollObj = Active) THEN BEGIN
                 ExitCode:= Precedent;
                 Break;
            END ELSE PreviousButton;

            IF ImmediateExit THEN Break;
      END;
      IF Key.Name = 'ENTER' THEN ExitCode:= Ok;
      IF Key.Name = 'ESC' THEN ExitCode:= Cancel;
 END;

 PROCEDURE TButton.Run;
 BEGIN
      IF CurButton^.Status = DisabledButton THEN NextButton;
      ViewButtons;
      Scroll;
 END;

 DESTRUCTOR TButton.Done;
 VAR Cur : PButtonItem;
 BEGIN
      TopOfList;
      WHILE Liste^.Suivant <> NIL DO BEGIN
            Cur:= Liste;
            Dispose(Cur);
            Cur:= NIL;
            Liste:= Liste^.Suivant;
      END;
      Cur:= Liste;
      Dispose(Cur);
      Liste:= NIL;
 END;

 {************}

 CONSTRUCTOR TListeVolets.Init;
 BEGIN
      Liste:= NIL; ScrollObj:= Inactive; Top:= NIL;
      WITH Rect DO BEGIN
           X1:= L1; X2:= L2; Y1:= C1; Y2:= C2;
      END;
      MaxLength:= 1;
      WITH Palette DO BEGIN
           Selected.X:= 00; Selected.Y:= 11;
           Unselected.X:= 15; Unselected.Y:= 3;
           Implicite.X:= 14; Implicite.Y:= 3;
      END;
 END;

 PROCEDURE TListeVolets.TopOfList; {Tte de la liste}
 BEGIN
      WHILE Liste^.Precedent <> NIL DO Liste:= Liste^.Precedent;
 END;

 PROCEDURE TListeVolets.NewItem; {Nouvel lment}
 VAR Nouveau : PListeItem;
 BEGIN
      New(Nouveau);
      IF Liste <> NIL THEN BEGIN
         WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
         Liste^.Suivant:= Nouveau;
         Nouveau^.Name:= ItemName;
         Nouveau^.Suivant:= NIL;
         Nouveau^.Precedent:= Liste;
         Liste:= Liste^.Suivant;
      END ELSE BEGIN
         Liste:= Nouveau;
         Liste^.Name:= ItemName;
         Liste^.Suivant:= NIL;
         Liste^.Precedent:= NIL;
      END;
      IF Length(Liste^.Name) > MaxLength THEN MaxLength:= Length(Liste^.Name);
      IF Top = NIL THEN Top:= Liste;
 END;

 PROCEDURE TListeVolets.AdjustItems; {Taille des lments kif-kif}
 VAR I : BYTE;
 BEGIN
      TopOfList;
      WHILE (Liste^.Suivant <> NIL) DO BEGIN
            IF Length(Liste^.Name) < MaxLength THEN
              FOR I:= Length(Liste^.Name) TO MaxLength-1 DO Liste^.Name:= Liste^.Name + ' ';
            Liste:= Liste^.Suivant;
            IF Length(Liste^.Name) < MaxLength THEN
              FOR I:= Length(Liste^.Name) TO MaxLength-1 DO Liste^.Name:= Liste^.Name + ' ';
      END;
 END;

 PROCEDURE TListeVolets.VertLine; {Dessine une ligne verticale}
 VAR I : BYTE;
 BEGIN
      FOR I:= X1 TO X2 DO TWrite(#179,I,Colonne);
 END;

 PROCEDURE TListeVolets.ClearVolets; {Efface l'espace rserv aux lments}
 VAR I,J : BYTE;
 BEGIN
      FOR I:= 0 TO NbVolets-1 DO FOR J:= Rect.X1 TO Rect.X2 DO
        IF Rect.Y1+(I*MaxLength+I+MaxLength) > Rect.Y2 THEN
          TWFromTo(' ',Rect.Y1+(I*MaxLength+I),Rect.Y2,J)
        ELSE TWFromTo(' ',Rect.Y1+(I*MaxLength+I),Rect.Y1+(I*MaxLength+I+MaxLength)-1,J);
 END;

 PROCEDURE TListeVolets.ViewList; {Montre les lments}
 VAR L,C,V : BYTE;
 BEGIN
      NbVolets:= (Rect.Y2-Rect.Y1-2) DIV MaxLength;
      TColor(Palette.UnSelected.X,Palette.UnSelected.Y);
      ClearVolets;
      L:= Rect.X1; C:= Rect.Y1; V:= 1;
      WHILE Lst <> NIL DO BEGIN
            IF Length(Lst^.Name)+C-1 > Rect.Y2 THEN
              TWrite(Copy(Lst^.Name,1,Rect.Y2-C+1), L,C) ELSE TWrite(Lst^.Name, L,C);
            L:= L+1;
            IF L > Rect.X2 THEN BEGIN
               L:= Rect.X1;
               C:= C+MaxLength+1;
               IF C > Rect.Y2 THEN Break;
               V:= V+1;
               IF V <= NbVolets THEN VertLine(Rect.X1,Rect.X2, C-1);
            END;

            IF V > NbVolets THEN Break;
            Lst:= Lst^.Suivant;
      END;
 END;

 PROCEDURE TListeVolets.NextItem;
 VAR I : BYTE;
 BEGIN
      IF Liste^.Suivant <> NIL THEN BEGIN
         Liste:= Liste^.Suivant;
         Ligne:= Ligne+1;
      END;
      IF (Ligne > Rect.X2) AND (Volet < NbVolets) THEN BEGIN
         Ligne:= Rect.X1; Col:= Col+MaxLength+1; Volet:= Volet+1;
      END;
      IF (Ligne > Rect.X2) AND (Volet = NbVolets) THEN BEGIN
         Ligne:= Rect.X1;
         FOR I:= 1 TO Rect.X2-Rect.X1+1 DO Top:= Top^.Suivant;
         ViewList(Top);
      END;
 END;

 PROCEDURE TListeVolets.PreviousItem;
 VAR I : BYTE;
 BEGIN
      IF Liste^.Precedent <> NIL THEN BEGIN
         Liste:= Liste^.Precedent;
         Ligne:= Ligne-1;
      END;
      IF (Ligne < Rect.X1) AND (Volet > 1) THEN BEGIN
         Ligne:= Rect.X2; Col:= Col-MaxLength-1; Volet:= Volet-1;
      END;
      IF (Ligne < Rect.X1) AND (Volet = 1) THEN BEGIN
         Ligne:= Rect.X2;
         FOR I:= 1 TO Rect.X2-Rect.X1+1 DO Top:= Top^.Precedent;
         ViewList(Top);
      END;
 END;

 PROCEDURE TListeVolets.Scroll; {Dplacements du curseur}
 VAR I,J : BYTE;
 BEGIN
      TopOfList;
      Key.Name:= ''; Top:= Liste; Ligne:= Rect.X1; Col:= Rect.Y1; Volet:= 1;
      WHILE (Key.Name <> 'ENTER') AND (Key.Name <> 'ESC') DO BEGIN
            TColor(Palette.Selected.X,Palette.Selected.Y);
            IF Length(Liste^.Name)+Col-1 > Rect.Y2 THEN
              TWrite(Copy(Liste^.Name,1,Rect.Y2-Col+1), Ligne,Col) ELSE TWrite(Liste^.Name, Ligne,Col);
            GetKey(Key);

            IF Copy(Key.Name,1,4) = 'GRAY' THEN BEGIN
               TColor(Palette.UnSelected.X,Palette.UnSelected.Y);
               IF Length(Liste^.Name)+Col-1 > Rect.Y2 THEN
                 TWrite(Copy(Liste^.Name,1,Rect.Y2-Col+1), Ligne,Col) ELSE TWrite(Liste^.Name, Ligne,Col);
            END;

            IF Key.Name = 'GRAY DOWN' THEN NextItem;

            IF Key.Name = 'GRAY UP' THEN PreviousItem;

            IF Key.Name = 'GRAY RIGHT' THEN FOR I:= 1 TO Rect.X2-Rect.X1+1 DO IF Liste^.Suivant <> NIL THEN BEGIN
               Liste:= Liste^.Suivant;
               Ligne:= Ligne+1;
               IF Ligne > Rect.X2 THEN BEGIN
                  Ligne:= Rect.X1;
                  Volet:= Volet+1;
                  IF Volet > NbVolets THEN BEGIN
                     Volet:= NbVolets;
                     FOR J:= 1 TO Rect.X2-Rect.X1+1 DO Top:= Top^.Suivant;
                     ViewList(Top);
                  END ELSE Col:= Col+MaxLength+1;
               END;
            END;

            IF Key.Name = 'GRAY LEFT' THEN FOR I:= 1 TO Rect.X2-Rect.X1+1 DO IF Liste^.Precedent <> NIL THEN BEGIN
               Liste:= Liste^.Precedent;
               Ligne:= Ligne-1;
               IF Ligne < Rect.X1 THEN BEGIN
                  Ligne:= Rect.X2;
                  Volet:= Volet-1;
                  IF Volet < 1 THEN BEGIN
                     Volet:= 1;
                     FOR J:= 1 TO Rect.X2-Rect.X1+1 DO Top:= Top^.Precedent;
                     ViewList(Top);
                  END ELSE Col:= Col-MaxLength-1;
               END;
            END;

            IF Key.Name = 'GRAY PGDOWN' THEN BEGIN
               Liste:= Top; Col:= Rect.Y1; Ligne:= Rect.X1; Volet:= 1;
               FOR I:= 1 TO (Rect.X2-Rect.X1+1)*((NbVolets*2)-2) DO IF Liste^.Suivant <> NIL THEN BEGIN
                   Liste:= Liste^.Suivant;
                   Ligne:= Ligne+1;
                   IF Ligne > Rect.X2 THEN BEGIN
                      Ligne:= Rect.X1;
                      Volet:= Volet+1;
                      IF Volet > NbVolets THEN BEGIN
                         Volet:= NbVolets;
                         FOR J:= 1 TO Rect.X2-Rect.X1+1 DO Top:= Top^.Suivant;
                      END ELSE Col:= Col+MaxLength+1;
                   END;
               END;
               ViewList(Top);
            END;

            IF Key.Name = 'GRAY PGUP' THEN BEGIN
               Col:= Rect.Y1; Volet:= 1; Ligne:= Rect.X1; Liste:= Top;
               FOR I:= 1 TO (Rect.X2-Rect.X1+1)*((NbVolets)-1) DO IF Liste^.Precedent <> NIL THEN BEGIN
                   Liste:= Liste^.Precedent;
                   Ligne:= Ligne-1;
                   IF Ligne < Rect.X1 THEN BEGIN
                      Ligne:= Rect.X2;
                      Volet:= Volet-1;
                      IF Volet < 1 THEN BEGIN
                         Volet:= 1;
                         FOR J:= 1 TO Rect.X2-Rect.X1+1 DO Top:= Top^.Precedent;
                      END ELSE Col:= Col-MaxLength-1;
                   END;
               END;
               ViewList(Top);
            END;

            IF Key.Name = 'GRAY HOME' THEN BEGIN
               Ligne:= Rect.X1; Col:= Rect.Y1; Volet:= 1; Liste:= Top;
            END;

            IF Key.Name = 'GRAY END' THEN BEGIN
               Ligne:= Rect.X1; Col:= Rect.Y1; Volet:= 1; Liste:= Top;
               FOR I:= 1 TO (Rect.X2-Rect.X1+1)*(NbVolets)-1 DO IF Liste^.Suivant <> NIL THEN BEGIN
                   Liste:= Liste^.Suivant;
                   Ligne:= Ligne+1;
                   IF Ligne > Rect.X2 THEN BEGIN
                      Ligne:= Rect.X1;
                      Volet:= Volet+1;
                      Col:= Col+MaxLength+1;
                   END;
               END;
            END;

            IF Key.Name = 'CTRL+GRAY END' THEN BEGIN
               Ligne:= Rect.X1; Col:= Rect.Y1; Volet:= 1; Liste:= Top;
               WHILE Liste^.Suivant <> NIL DO BEGIN
                   Liste:= Liste^.Suivant;
                   Ligne:= Ligne+1;
                   IF Ligne > Rect.X2 THEN BEGIN
                      Ligne:= Rect.X1;
                      Volet:= Volet+1;
                      IF Volet > NbVolets THEN BEGIN
                         Volet:= NbVolets;
                         FOR J:= 1 TO Rect.X2-Rect.X1+1 DO Top:= Top^.Suivant;
                      END ELSE Col:= Col+MaxLength+1;
                   END;
               END;
               ViewList(Top);
            END;

            IF Key.Name = 'CTRL+GRAY HOME' THEN BEGIN
               Ligne:= Rect.X1; Col:= Rect.Y1; Volet:= 1; TopOfList;
               Top:= Liste;
               ViewList(Top);
            END;

            IF (Key.Name = 'TAB') AND (ScrollObj = Active) THEN BEGIN
               ExitCode:= Next;
               Break;
            END;

            IF (Key.Name = 'SHIFT+TAB') AND (ScrollObj = Active) THEN BEGIN
               ExitCode:= Next;
               Break;
            END;

            IF Key.Name = 'ESC' THEN ExitCode:= Cancel;
            IF Key.Name = 'ENTER' THEN ExitCode:= Ok;
      END;
      TColor(Palette.Implicite.X,Palette.Implicite.Y);
      IF Length(Liste^.Name)+Col-1 > Rect.Y2 THEN
       TWrite(Copy(Liste^.Name,1,Rect.Y2-Col+1), Ligne,Col) ELSE TWrite(Liste^.Name, Ligne,Col);
      {Element 'implicite'}
      ListeExitStr:= Liste^.Name;
 END;

 DESTRUCTOR TListeVolets.Done; {Dtruit la liste et libre l'espace
                                      allou. NOT Ok en mode PROTEGE}
 VAR Cur : PListeItem;
 BEGIN
      TopOfList;
      WHILE Liste <> NIL DO BEGIN
            Cur:= Liste;
            Dispose(Cur);
            Cur:= NIL;
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
      END;
      Liste:= NIL;
 END;

 PROCEDURE TListeVolets.Run; {Ajuste, affiche, scrolling}
 BEGIN
      AdjustItems;
      ViewList(Top);
      Scroll;
 END;

 {********}

 CONSTRUCTOR TListe.Init;
 BEGIN
      Liste:= NIL; CurItem:= NIL; ScrollObj:= Inactive; Top:= NIL;
      ExitCode:= 255; ImmediateExit:= FALSE;
      WITH Rect DO BEGIN
           X1:= L1; X2:= L2; Y1:= C1; Y2:= C2;
      END;
      Ligne:= Rect.X1;
      WITH Palette DO BEGIN
           Selected.X:= 00; Selected.Y:= 11;
           Unselected.X:= 15; Unselected.Y:= 3;
           Implicite.X:= 14; Implicite.Y:= 3;
      END;
 END;

 PROCEDURE TListe.TopOfList; {Tte de la liste}
 BEGIN
      WHILE Liste^.Precedent <> NIL DO Liste:= Liste^.Precedent;
 END;

 PROCEDURE TListe.EndOfList; {Tte de la liste}
 BEGIN
      WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
 END;

 PROCEDURE TListe.NewItem; {Nouvel lment}
 VAR Nouveau : PListeItem;
 BEGIN
      New(Nouveau);
      IF Liste <> NIL THEN BEGIN
         WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
         Liste^.Suivant:= Nouveau;
         Nouveau^.Name:= ItemName;
         Nouveau^.Suivant:= NIL;
         Nouveau^.Precedent:= Liste;
         Liste:= Liste^.Suivant;
      END ELSE BEGIN
         Liste:= Nouveau;
         Liste^.Name:= ItemName;
         Liste^.Suivant:= NIL;
         Liste^.Precedent:= NIL;
      END;
      IF Top = NIL THEN Top:= Liste;
      IF CurItem = NIL THEN CurItem:= Liste;
 END;

 PROCEDURE TListe.NextItem;
 BEGIN
      IF Liste = NIL THEN Exit;
      IF CurItem^.Suivant <> NIL THEN BEGIN
         CurItem:= CurItem^.Suivant;
         Ligne:= Ligne+1;
         IF Ligne > Rect.X2 THEN BEGIN
            Ligne:= Rect.X2;
            Top:= Top^.Suivant;
            ViewItems;
         END;
      END;
 END;

 PROCEDURE TListe.PreviousItem;
 BEGIN
      IF Liste = NIL THEN Exit;
      IF CurItem^.Precedent <> NIL THEN BEGIN
         CurItem:= CurItem^.Precedent;
         Ligne:= Ligne-1;
         IF Ligne < Rect.X1 THEN BEGIN
            Ligne:= Rect.X1;
            Top:= Top^.Precedent;
            ViewItems;
         END;
      END;
 END;

 PROCEDURE TListe.FirstItem;
 BEGIN
      IF Liste = NIL THEN Exit;
      WHILE CurItem^.Precedent <> NIL DO BEGIN
            CurItem:= CurItem^.Precedent;
            Ligne:= Ligne-1;
            IF Ligne < Rect.X1 THEN BEGIN
               Ligne:= Rect.X1;
               Top:= Top^.Precedent;
            END;
      END;
      ViewItems;
 END;

 PROCEDURE TListe.LastItem;
 BEGIN
      IF Liste = NIL THEN Exit;
      WHILE CurItem^.Suivant <> NIL DO BEGIN
            CurItem:= CurItem^.Suivant;
            Ligne:= Ligne+1;
            IF Ligne > Rect.X2 THEN BEGIN
               Ligne:= Rect.X2;
               Top:= Top^.Suivant;
            END;
      END;
      ViewItems;
 END;

 PROCEDURE TListe.ItemSelect;
 VAR I : BYTE;
 BEGIN
      IF Liste = NIL THEN Exit;
      TColor(Palette.Selected.X, Palette.Selected.Y);
      FOR I:= Rect.Y1 TO Rect.Y2 DO TWrite(' ',Ligne,I);
      TWrite(CurItem^.Name, Ligne,Rect.Y1);
 END;

 PROCEDURE TListe.ItemUnselect;
 VAR I : BYTE;
 BEGIN
      IF Liste = NIL THEN Exit;
      TColor(Palette.Unselected.X, Palette.Unselected.Y);
      FOR I:= Rect.Y1 TO Rect.Y2 DO TWrite(' ',Ligne,I);
      TWrite(CurItem^.Name, Ligne,Rect.Y1);
 END;

 PROCEDURE TListe.ItemImplicite;
 VAR I : BYTE;
 BEGIN
      IF Liste = NIL THEN Exit;
      TColor(Palette.Implicite.X, Palette.Implicite.Y);
      FOR I:= Rect.Y1 TO Rect.Y2 DO TWrite(' ',Ligne,I);
      TWrite(CurItem^.Name, Ligne,Rect.Y1);
 END;

 PROCEDURE TListe.DeleteItem;
 VAR Cur : PListeItem;
 BEGIN
      IF Liste = NIL THEN Exit;
      TopOfList;
      Cur:= Liste;
      WHILE Liste <> NIL DO BEGIN
            IF Liste^.Name = ItemName THEN BEGIN
               Cur:= Liste;
               Dispose(Cur);
               Cur:= NIL;
               IF (Liste^.Precedent <> NIL) AND (Liste^.Suivant <> NIL) THEN BEGIN
                  Liste^.Precedent^.Suivant:= Liste^.Suivant;
                  IF Top = Liste THEN Top:= Top^.Precedent ELSE Ligne:= Ligne-1;
                  Liste^.Suivant^.Precedent:= Liste^.Precedent;
                  Liste:= Liste^.Suivant;


                  NextItem;

                  ViewItems;
                  Break;
               END;
               IF (Liste^.Precedent = NIL) AND (Liste^.Suivant = NIL) THEN BEGIN
                  Top:= NIL;
                  ViewItems;
                  Break;
               END;
               IF Liste^.Precedent = NIL THEN BEGIN
                  Liste^.Suivant^.Precedent:= NIL;
                  IF Top = Liste THEN Top:= Top^.Suivant;
                  Liste:= Liste^.Suivant;

                  Ligne:= Ligne-1;
                  NextItem;

                  ViewItems;
                  Break;
               END;
               IF Liste^.Suivant = NIL THEN BEGIN
                  Liste^.Precedent^.Suivant:= NIL;
                  Liste:= Liste^.Precedent;
                  PreviousItem;
                  ViewItems;
                  Break;
               END;
            END;
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
      END;
 END;

 PROCEDURE TListe.ViewItems;
 VAR Last : PListeItem;
     L    : BYTE;
 BEGIN
      TDrawBox(Rect.X1,Rect.Y1,Rect.X2,Rect.Y2, Palette.Unselected.X,Palette.Unselected.Y, Off, NoBorder);
      IF Liste = NIL THEN Exit;
      Last:= CurItem; L:= Ligne;
      Ligne:= Rect.X1;
      CurItem:= Top;
      WHILE CurItem <> NIL DO BEGIN
            IF CurItem = Last THEN ItemImplicite ELSE ItemUnselect;
            IF (Ligne >= Rect.X2) OR (CurItem^.Suivant = NIL) THEN Break;
            NextItem;
      END;
      CurItem:= Last;
      Ligne:= L;
 END;

 PROCEDURE TListe.Scroll;
 BEGIN
      ExitCode:= 255;
      Key.Name:= '';
      WHILE (Key.Name <> 'ESC') AND (Key.Name <> 'ENTER') DO BEGIN
            ItemSelect;
            GetKey(Key);
            IF Copy(Key.Name,1,4) = 'GRAY' THEN ItemUnselect;

            IF Key.Name = 'GRAY DOWN' THEN NextItem;
            IF Key.Name = 'GRAY UP' THEN PreviousItem;
            IF Key.Name = 'GRAY HOME' THEN FirstItem;
            IF Key.Name = 'GRAY END' THEN LastItem;
            IF Key.Name = 'ENTER' THEN ExitCode:= Ok;
            IF Key.Name = 'ESC' THEN ExitCode:= Cancel;

            IF Key.Name = 'TAB' THEN IF ScrollObj = Active THEN BEGIN
               ExitCode:= Next;
               Key.Name:= 'ENTER';
            END;
            IF Key.Name = 'SHIFT+TAB' THEN IF ScrollObj = Active THEN BEGIN
               ExitCode:= Precedent;
               Key.Name:= 'ENTER';
            END;
            IF ImmediateExit THEN Break;
      END;
      ItemImplicite;
 END;


 PROCEDURE TListe.Run;
 BEGIN
      ViewItems;
      Scroll;
 END;

 DESTRUCTOR TListe.Done;
 VAR Cur : PListeItem;
 BEGIN
      IF Liste = NIL THEN Exit;
      TopOfList;
      WHILE Liste <> NIL DO BEGIN
            Cur:= Liste;
            Dispose(Liste);
            Cur:= NIL;
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
      END;
      Liste:= NIL;
 END;

 {**********}

 CONSTRUCTOR TPullDownListe.Init;
 BEGIN
      Liste:= NIL; CurItem:= NIL; ScrollObj:= Inactive; Top:= NIL; Scr:= NIL;
      WITH Rect DO BEGIN
           X1:= L1; X2:= L2; Y1:= C1; Y2:= C2;
      END;
      Ligne:= Rect.X1+1; PullDown:= FALSE; ScrollObj:= Inactive;
      WITH Palette DO BEGIN
           SelectedItem.X:= 15; SelectedItem.Y:= 02;
           UnselectedItem.X:= 15; UnselectedItem.Y:= 3;
           SelectedField.X:= 15; SelectedField.Y:= 3;
           UnselectedField.X:= 00; UnselectedField.Y:= 3;
           Border.X:= 15; Border.Y:= 3;
           Arrow.X:= 00; Arrow.Y:= 2;
      END;
 END;

 PROCEDURE TPullDownListe.TopOfList; {Tte de la liste}
 BEGIN
      IF Liste <> NIL THEN WHILE Liste^.Precedent <> NIL DO Liste:= Liste^.Precedent;
 END;

 PROCEDURE TPullDownListe.EndOfList; {Tte de la liste}
 BEGIN
      IF Liste <> NIL THEN WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
 END;

 PROCEDURE TPullDownListe.NewItem; {Nouvel lment}
 VAR Nouveau : PListeItem;
 BEGIN
      New(Nouveau);
      IF Liste <> NIL THEN BEGIN
         WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
         Liste^.Suivant:= Nouveau;
         Nouveau^.Name:= ItemName;
         Nouveau^.Suivant:= NIL;
         Nouveau^.Precedent:= Liste;
         Liste:= Liste^.Suivant;
      END ELSE BEGIN
         Liste:= Nouveau;
         Liste^.Name:= ItemName;
         Liste^.Suivant:= NIL;
         Liste^.Precedent:= NIL;
      END;
      IF Top = NIL THEN Top:= Liste;
      IF CurItem = NIL THEN CurItem:= Liste;
 END;

 PROCEDURE TPullDownListe.NextItem;
 BEGIN
      IF CurItem^.Suivant <> NIL THEN BEGIN
         CurItem:= CurItem^.Suivant;
         Ligne:= Ligne+1;
         IF Ligne > Rect.X2-1 THEN BEGIN
            Ligne:= Rect.X2-1;
            Top:= Top^.Suivant;
            ViewItems;
         END;
      END;
 END;

 PROCEDURE TPullDownListe.PreviousItem;
 BEGIN
      IF CurItem^.Precedent <> NIL THEN BEGIN
         CurItem:= CurItem^.Precedent;
         Ligne:= Ligne-1;
         IF Ligne < Rect.X1+1 THEN BEGIN
            Ligne:= Rect.X1+1;
            Top:= Top^.Precedent;
            ViewItems;
         END;
      END;
 END;

 PROCEDURE TPullDownListe.ItemSelect;
 VAR I : BYTE;
 BEGIN
      TColor(Palette.SelectedItem.X, Palette.SelectedItem.Y);
      FOR I:= Rect.Y1+1 TO Rect.Y2-1 DO TWrite(' ',Ligne,I);
      TWrite(Copy(CurItem^.Name,1,Rect.Y2+1-Rect.Y1-1), Ligne,Rect.Y1+1);
 END;

 PROCEDURE TPullDownListe.ItemUnselect;
 VAR I : BYTE;
 BEGIN
      TColor(Palette.UnselectedItem.X, Palette.UnselectedItem.Y);
      FOR I:= Rect.Y1+1 TO Rect.Y2-1 DO TWrite(' ',Ligne,I);
      TWrite(Copy(CurItem^.Name,1,Rect.Y2+1-Rect.Y1-1), Ligne,Rect.Y1+1);
 END;

 PROCEDURE TPullDownListe.FieldSelect;
 VAR I : BYTE;
 BEGIN
      TColor(Palette.SelectedField.X, Palette.SelectedField.Y);
      TMkSpace(Rect.Y1,Rect.Y2-4, Rect.X1);
      TWrite(Copy(CurItem^.Name,1,Rect.Y2-Rect.Y1+1-2-4), Rect.X1, Rect.Y1+1);
 END;

 PROCEDURE TPullDownListe.FieldUnselect;
 VAR I : BYTE;
 BEGIN
      TColor(Palette.UnselectedField.X, Palette.UnselectedField.Y);
      TMkSpace(Rect.Y1,Rect.Y2-4, Rect.X1);
      TWrite(Copy(CurItem^.Name,1,Rect.Y2-Rect.Y1+1-2-4), Rect.X1, Rect.Y1+1);
 END;

 PROCEDURE TPullDownListe.DrawPullDownArrow;
 BEGIN
      TColor(Palette.Arrow.Y, Palette.Arrow.X);
      TWrite(' ',Rect.X1,Rect.Y2-2);
      TColor(Palette.Arrow.X, Palette.Arrow.Y);
      TWrite('',Rect.X1,Rect.Y2-1);
 END;

 PROCEDURE TPullDownListe.DrawBorder;
 BEGIN
      TDrawBox(Rect.X1,Rect.Y1,Rect.X2,Rect.Y2, Palette.Border.X,Palette.Border.Y, On, Double);
 END;

 PROCEDURE TPullDownListe.DeleteItem;
 VAR Cur : PListeItem;
 BEGIN
      TopOfList;
      Cur:= Liste;
      WHILE Liste <> NIL DO BEGIN
            IF Liste^.Name = ItemName THEN BEGIN
               Cur:= Liste;
               Dispose(Cur);
               Cur:= NIL;
               IF (Liste^.Precedent <> NIL) AND (Liste^.Suivant <> NIL) THEN BEGIN
                  Liste^.Precedent^.Suivant:= Liste^.Suivant;
                  IF Top = Liste THEN Top:= Top^.Precedent ELSE Ligne:= Ligne-1;
                  Liste^.Suivant^.Precedent:= Liste^.Precedent;
                  Liste:= Liste^.Suivant;


                  NextItem;

                  ViewItems;
                  Break;
               END;
               IF Liste^.Precedent = NIL THEN BEGIN
                  Liste^.Suivant^.Precedent:= NIL;
                  IF Top = Liste THEN Top:= Top^.Suivant;
                  Liste:= Liste^.Suivant;

                  Ligne:= Ligne-1;
                  NextItem;

                  ViewItems;
                  Break;
               END;
               IF Liste^.Suivant = NIL THEN BEGIN
                  Liste^.Precedent^.Suivant:= NIL;
                  Liste:= Liste^.Precedent;
                  PreviousItem;
                  ViewItems;
                  Break;
               END;
            END;
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
      END;
 END;

 PROCEDURE TPullDownListe.ViewItems;
 VAR Last : PListeItem;
     L    : BYTE;
 BEGIN
      IF PullDown THEN BEGIN
      IF Scr = NIL THEN BEGIN
         New(Scr);
         GetScr(Rect.X1,Rect.Y1,Rect.X2+1,Rect.Y2+2, Scr^);
      END;
      DrawBorder;
      Last:= CurItem; L:= Ligne;
      Ligne:= Rect.X1+1;
      CurItem:= Top;
      WHILE CurItem <> NIL DO BEGIN
            ItemUnselect;
            IF (Ligne >= Rect.X2-1) OR (CurItem^.Suivant = NIL) THEN Break;
            NextItem;
      END;
      CurItem:= Last;
      Ligne:= L;
      END ELSE BEGIN
          FieldUnSelect; DrawPullDownArrow;
      END;
 END;

 PROCEDURE TPullDownListe.Scroll;
 BEGIN
      Key.Name:= '';
      WHILE (Key.Name <> 'ESC') DO BEGIN
            CASE PullDown OF
                 FALSE : BEGIN
                       ViewItems;
                       FieldSelect;
                       GetKey(Key);
                       IF Key.Name = 'ESC' THEN ExitCode:= Cancel;
                       IF Key.Name = 'GRAY DOWN' THEN BEGIN
                          PullDown:= TRUE;
                          ViewItems;
                       END;
                       IF Key.Name = 'ENTER' THEN BEGIN
                          ExitCode:= Ok;
                          IF Scr <> NIL THEN SetScr(Rect.X1,Rect.Y1,Rect.X2+1,Rect.Y2+2, Scr^);
                          Key.Name:= 'ESC';
                       END;
                       IF Key.Name = 'TAB' THEN BEGIN
                          ExitCode:= Next;
                          IF Scr <> NIL THEN SetScr(Rect.X1,Rect.Y1,Rect.X2+1,Rect.Y2+2, Scr^);
                          Key.Name:= 'ESC';
                       END;
                       IF Key.Name = 'SHIFT+TAB' THEN BEGIN
                          ExitCode:= Precedent;
                          IF Scr <> NIL THEN SetScr(Rect.X1,Rect.Y1,Rect.X2+1,Rect.Y2+2, Scr^);
                          Key.Name:= 'ESC';
                       END;
                 END;

                 TRUE  : BEGIN
                       ItemSelect;
                       GetKey(Key);
                       IF Copy(Key.Name,1,4) = 'GRAY' THEN ItemUnselect;

                       IF Key.Name = 'GRAY DOWN' THEN NextItem;
                       IF Key.Name = 'GRAY UP' THEN PreviousItem;
                       IF Key.Name = 'ENTER' THEN BEGIN
                          ExitCode:= Ok;
                          SetScr(Rect.X1,Rect.Y1,Rect.X2+1,Rect.Y2+2, Scr^);
                          PullDown:= FALSE;
                       END;
                       IF Key.Name = 'ESC' THEN Key.Name:= '';
                 END;
            END;{CASE}
      END;
      IF Scr <> NIL THEN BEGIN
         SetScr(Rect.X1,Rect.Y1,Rect.X2+1,Rect.Y2+2, Scr^); Dispose(Scr); Scr:= NIL;
      END;
      FieldUnselect;
 END;

 PROCEDURE TPullDownListe.Run;
 BEGIN
      ViewItems;
      Scroll;
 END;

 DESTRUCTOR TPullDownListe.Done;
 VAR Cur : PListeItem;
 BEGIN
      TopOfList;
      WHILE Liste <> NIL DO BEGIN
            Cur:= Liste;
            Dispose(Cur);
            Cur:= NIL;
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
      END;
      Liste:= NIL;
 END;

 {**********}

 CONSTRUCTOR TField.Init;
 BEGIN
      Liste:= NIL; CurField:= NIL; ScrollObj:= Inactive;
      PosCur:= 1; PosStr:= 1;

      WITH Palette DO BEGIN
           Selected.X:= 15; Selected.Y:= 2;
           Unselected.X:= 15; Unselected.Y:= 1;
           SelectedTitle.X:= 14; SelectedTitle.Y:= 07;
           UnselectedTitle.X:= 00; UnselectedTitle.Y:= 7;
      END;
 END;

 PROCEDURE TField.NewField;
 VAR Nouveau : PFieldItem;
 BEGIN
      New(Nouveau);
      IF Liste <> NIL THEN BEGIN
         WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
         Liste^.Suivant:= Nouveau;
         Nouveau^.Name:= FieldName;
         Nouveau^.Data:= FieldData;
         Nouveau^.StartSel:= 0;
         Nouveau^.EndSel:= 0;
         Nouveau^.MaxLength:= Len;
         Nouveau^.Ch:= ChF;
         Nouveau^.Ligne:= L;
         Nouveau^.Col:= C;
         Nouveau^.Suivant:= NIL;
         Nouveau^.Precedent:= Liste;
         Liste:= Liste^.Suivant;
      END ELSE BEGIN
         Liste:= Nouveau;
         Liste^.Name:= FieldName;
         Liste^.Data:= FieldData;
         Liste^.StartSel:= 0;
         Liste^.EndSel:= 0;
         Liste^.MaxLength:= Len;
         Liste^.Ch:= ChF;
         Liste^.Ligne:= L;
         Liste^.Col:= C;
         Liste^.Suivant:= NIL;
         Liste^.Precedent:= NIL;
      END;
      IF CurField = NIL THEN CurField:= Liste;
 END;

 PROCEDURE TField.TopOfList;
 BEGIN
      WHILE Liste^.Precedent <> NIL DO Liste:= Liste^.Precedent;
 END;

 PROCEDURE TField.EndOfList; {Queue de la liste}
 BEGIN
      WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
 END;

 PROCEDURE TField.FirstField;
 BEGIN
      TopOfList; CurField:= Liste;
 END;

 PROCEDURE TField.LastField;
 BEGIN
      EndOfList; CurField:= Liste;
 END;

 PROCEDURE TField.NextField;
 BEGIN
      IF CurField^.Suivant <> NIL THEN CurField:= CurField^.Suivant ELSE BEGIN
         TopOfList;
         CurField:= Liste;
      END;
      TColor(Palette.SelectedTitle.X,Palette.SelectedTitle.Y);
      TWrite(CurField^.Name,CurField^.Ligne,CurField^.Col);
 END;

 PROCEDURE TField.PreviousField;
 BEGIN
      IF CurField^.Precedent <> NIL THEN CurField:= CurField^.Precedent ELSE BEGIN
         EndOfList;
         CurField:= Liste;
      END;
      TColor(Palette.SelectedTitle.X,Palette.SelectedTitle.Y);
      TWrite(CurField^.Name,CurField^.Ligne,CurField^.Col);
 END;

 PROCEDURE TField.Draw;
 BEGIN
      TColor(Palette.Unselected.X,Palette.Unselected.Y);
      TMkSpace(CurField^.Col,CurField^.Col+CurField^.MaxLength+1, CurField^.Ligne+1);
      TWrite(Copy(CurField^.Data,PosStr-PosCur+1,CurField^.MaxLength),CurField^.Ligne+1,CurField^.Col+1);

      TColor(Palette.UnselectedTitle.X,Palette.UnselectedTitle.Y);
      TWrite(CurField^.Name,CurField^.Ligne,CurField^.Col);
 END;

 PROCEDURE TField.Assign;
 BEGIN
      CurField^.Data:= FieldData;
 END;

 PROCEDURE TField.ViewFields;
 VAR Last : PFieldItem;
 BEGIN
      Last:= CurField;
      TopOfList;
      CurField:= Liste;
      WHILE CurField <> NIL DO BEGIN
            Draw;
            TColor(Palette.Arrows.X,Palette.Arrows.Y);

            IF PosStr-PosCur >= 1 THEN TWrite(#27, CurField^.Ligne+1,CurField^.Col);

            IF Length(CurField^.Data)-PosStr > CurField^.MaxLength-PosCur THEN
              TWrite(#26, CurField^.Ligne+1,CurField^.Col+CurField^.MaxLength+1);

            IF CurField^.Suivant <> NIL THEN CurField:= CurField^.Suivant ELSE Break;
      END;
      CurField:= Last;
 END;

 PROCEDURE TField.Input;
 VAR KeyInpt : KeyInfo;
     Ref     : BOOLEAN;

 PROCEDURE ReDraw;
 BEGIN
      TColor(Palette.Unselected.X,Palette.Unselected.Y);
      TMkSpace(CurField^.Col,CurField^.Col+CurField^.MaxLength+1, CurField^.Ligne+1);
      TWrite(Copy(CurField^.Data,PosStr-PosCur+1,CurField^.MaxLength),CurField^.Ligne+1,CurField^.Col+1);

      TColor(Palette.SelectedTitle.X,Palette.SelectedTitle.Y);
      TWrite(CurField^.Name,CurField^.Ligne,CurField^.Col);

      TColor(Palette.Arrows.X,Palette.Arrows.Y);

      IF PosStr-PosCur >= 1 THEN TWrite(#27, CurField^.Ligne+1,CurField^.Col);

      IF Length(CurField^.Data)-PosStr > CurField^.MaxLength-PosCur THEN
        TWrite(#26, CurField^.Ligne+1,CurField^.Col+CurField^.MaxLength+1);

      IF Ref THEN SetCursorSize(1,16) ELSE SetCursorSize(15,16);
      SetCursorPos(CurField^.Ligne+1,CurField^.Col+PosCur);
 END;

 PROCEDURE Avance;
 BEGIN
      PosCur:= PosCur+1;
      PosStr:= PosStr+1;
      IF PosStr > Length(CurField^.Data)+1 THEN PosStr:= PosStr-1;
      IF (PosCur > CurField^.MaxLength+1) OR (PosCur > Length(CurField^.Data)+1) THEN PosCur:= PosCur-1;
 END;

 PROCEDURE Arriere;
 BEGIN
      PosCur:= PosCur-1;
      PosStr:= PosStr-1;
      IF PosCur < 1 THEN PosCur:= PosCur+1;
      IF PosStr < 1 THEN PosStr:= 1;
 END;

 PROCEDURE BackSp; {Effacer arrire}
 BEGIN
      IF PosStr > 1 THEN DelChar(PosStr-1, CurField^.Data) ELSE DelChar(1, CurField^.Data);
      IF PosStr-PosCur+1 = 1 THEN Arriere ELSE PosStr:= PosStr-1;
 END;

 PROCEDURE Del;
 BEGIN
      DelChar(PosStr, CurField^.Data);
 END;

 PROCEDURE Add;
 BEGIN
      IF Ref = FALSE THEN InsChar(PosStr,Chr(KeyInpt.ASCII),CurField^.Data)
        ELSE CurField^.Data[PosStr]:= Chr(KeyInpt.ASCII);
      Avance;
 END;

 PROCEDURE Top;
 BEGIN
      PosCur:= 1; PosStr:= 1;
 END;

 PROCEDURE Endd;
 BEGIN
      WHILE PosStr <> Length(CurField^.Data)+1 DO Avance;
 END;

 BEGIN
      KeyInpt.Name:= ''; KeyInpt.ASCII:= 0; Ref:= FALSE;
      ShowCursor;
      WHILE (KeyInpt.Name <> 'ENTER') AND (KeyInpt.Name <> 'ESC') DO BEGIN
            ReDraw;
            GetKey(KeyInpt);

            IF Copy(KeyInpt.Name,1,4) = 'GRAY' THEN BEGIN
               IF KeyInpt.Name = 'GRAY RIGHT' THEN Avance;
               IF KeyInpt.Name = 'GRAY LEFT' THEN Arriere;
               IF KeyInpt.Name = 'GRAY SUPPR' THEN Del;
               IF KeyInpt.Name = 'GRAY HOME' THEN Top;
               IF KeyInpt.Name = 'GRAY END' THEN Endd;
               IF KeyInpt.Name = 'GRAY INSERT' THEN Ref:= NOT Ref;
            END ELSE IF Chr(KeyInpt.ASCII) IN CurField^.Ch THEN Add;

            IF KeyInpt.Name = 'BACKSPACE' THEN BackSp;
            IF KeyInpt.Name = 'ENTER' THEN BEGIN
               ExitCode:= Ok;
            END;
            IF KeyInpt.Name = 'ESC' THEN BEGIN
               ExitCode:= Cancel;
            END;
            IF KeyInpt.Name = 'TAB' THEN BEGIN
               IF (ScrollObj = Active) AND (CurField^.Suivant = NIL) THEN BEGIN
                  ExitCode:= Next;
                  KeyInpt.Name:= 'ENTER';
               END ELSE BEGIN
                  PosCur:= 1; PosStr:= 1;
                  TColor(Palette.UnselectedTitle.X,Palette.UnselectedTitle.Y);
                  TWrite(CurField^.Name,CurField^.Ligne,CurField^.Col);
                  NextField;
               END;
            END;

            IF KeyInpt.Name = 'SHIFT+TAB' THEN BEGIN
               IF (ScrollObj = Active) AND (CurField^.Precedent = NIL) THEN BEGIN
                  ExitCode:= Precedent;
                  KeyInpt.Name:= 'ENTER';
               END ELSE BEGIN
                  PosCur:= 1; PosStr:= 1;
                  TColor(Palette.UnselectedTitle.X,Palette.UnselectedTitle.Y);
                  TWrite(CurField^.Name,CurField^.Ligne,CurField^.Col);
                  PreviousField;
               END;
            END;
      END;
      Top;
      TColor(Palette.UnselectedTitle.X,Palette.UnselectedTitle.Y);
      TWrite(CurField^.Name,CurField^.Ligne,CurField^.Col);
      HideCursor;
 END;

 PROCEDURE TField.Run;
 BEGIN
      ViewFields;
      Input;
 END;

 FUNCTION TField.GetData;
 BEGIN
      TopOfList;
      WHILE Liste <> NIL DO BEGIN
            IF Liste^.Name = FieldName THEN BEGIN
               GetData:= Liste^.Data;
               Break;
            END;
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
      END;
 END;

 DESTRUCTOR TField.Done;
 VAR Cur : PFieldItem;
 BEGIN
      TopOfList;
      WHILE Liste^.Suivant <> NIL DO BEGIN
            Cur:= Liste;
            Dispose(Cur);
            Cur:= NIL;
            Liste:= Liste^.Suivant;
      END;
      Cur:= Liste;
      Dispose(Cur);
      Liste:= NIL;
 END;

 {***********}

 CONSTRUCTOR TWindow.Init;
 BEGIN
      Liste:= NIL; CurWindow:= NIL; ScrollObj:= Inactive;
      WITH Palette DO BEGIN
           Active.X:= 15; Active.Y:= 7;
           Passive.X:= 8; Passive.Y:= 7;
           Title.X:= 15; Title.Y:= 7;
           Close.X:= 11; Close.Y:= 7;
      END;
 END;

 PROCEDURE TWindow.NewWindow;
 VAR Nouveau : PWindowItem;
 BEGIN
      New(Nouveau);
      IF Liste <> NIL THEN BEGIN
         WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
         Liste^.Suivant:= Nouveau;
         Nouveau^.Title:= WindowTitle;
         Nouveau^.Shadow:= Sh;
         WITH Nouveau^.Rect DO BEGIN
              X1:= L1; X2:= L2; Y1:= C1; Y2:= C2;
         END;
         Nouveau^.Suivant:= NIL;
         Nouveau^.Precedent:= Liste;
         Liste:= Liste^.Suivant;
      END ELSE BEGIN
         Liste:= Nouveau;
         Liste^.Title:= WindowTitle;
         Liste^.Shadow:= Sh;
         WITH Liste^.Rect DO BEGIN
              X1:= L1; X2:= L2; Y1:= C1; Y2:= C2;
         END;
         Liste^.Suivant:= NIL;
         Liste^.Precedent:= NIL;
      END;
      IF CurWindow = NIL THEN CurWindow:= Liste;
 END;

 PROCEDURE TWindow.TopOfList;
 BEGIN
      WHILE Liste^.Precedent <> NIL DO Liste:= Liste^.Precedent;
 END;

 PROCEDURE TWindow.EndOfList; {Queue de la liste}
 BEGIN
      WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
 END;

 PROCEDURE TWindow.NextWindow;
 BEGIN
      IF CurWindow^.Suivant <> NIL THEN CurWindow:= CurWindow^.Suivant ELSE BEGIN
         TopOfList;
         CurWindow:= Liste;
      END;
 END;

 PROCEDURE TWindow.PreviousWindow;
 BEGIN
      IF CurWindow^.Precedent <> NIL THEN CurWindow:= CurWindow^.Precedent ELSE BEGIN
         EndOfList;
         CurWindow:= Liste;
      END;
 END;

 PROCEDURE TWindow.FillWindow;
 BEGIN
      WITH CurWindow^.Rect DO TDrawBox(X1+1,Y1+1,X2-1,Y2-1, Palette.Active.X,Palette.Active.Y, Off, NoBorder);
 END;

 PROCEDURE TWindow.DrawActiveTitle;
 BEGIN
      TColor(Palette.Title.X,Palette.Title.Y);
      TCenterXY(' '+CurWindow^.Title+' ', CurWindow^.Rect.X1, CurWindow^.Rect.Y1+1,CurWindow^.Rect.Y2-1);
 END;

 PROCEDURE TWindow.DrawPassiveTitle;
 BEGIN
      TColor(Palette.Passive.X,Palette.Passive.Y);
      TCenterXY(' '+CurWindow^.Title+' ', CurWindow^.Rect.X1, CurWindow^.Rect.Y1+1,CurWindow^.Rect.Y2-1);
 END;

 PROCEDURE TWindow.WindowUnselect;
 VAR I : BYTE;
 BEGIN
      WITH CurWindow^.Rect DO BEGIN
           TColor(Palette.Passive.X,Palette.Passive.Y);
           TWFromTo(#196,Y1+1,Y2-1,X1);
           TWFromTo(#196,Y1+1,Y2-1,X2);
           FOR I:= X1+1 TO X2-1 DO BEGIN
               TWrite(#179,I,Y1);
               TWrite(#179,I,Y2);
           END;
           TWrite(#218,X1,Y1);
           TWrite(#191,X1,Y2);
           TWrite(#192,X2,Y1);
           TWrite(#217,X2,Y2);
           IF CurWindow^.Shadow = On THEN BEGIN
              FOR I:= X1+1 TO X2+1 DO Mem[SegB800:(TScreenSize.X*(I-1)+(Y2))*2+1]:= 8;
              FOR I:= X1+1 TO X2+1 DO Mem[SegB800:(TScreenSize.X*(I-1)+(Y2+1))*2+1]:= 8;
              FOR I:= Y1+2 TO Y2+2 DO Mem[SegB800:(TScreenSize.X*(X2)+(I-1))*2+1]:= 8;
           END;
      END;
      DrawPassiveTitle;
 END;

 PROCEDURE TWindow.WindowSelect;
 VAR I : BYTE;
 BEGIN
      WITH CurWindow^.Rect DO BEGIN
           TColor(Palette.Active.X,Palette.Active.Y);
           TWFromTo(#205,Y1+1,Y2-1,X1);
           TWFromTo(#205,Y1+1,Y2-1,X2);
           FOR I:= X1+1 TO X2-1 DO BEGIN
               TWrite(#186,I,Y1);
               TWrite(#186,I,Y2);
           END;
           TWrite(#201,X1,Y1);
           TWrite(#187,X1,Y2);
           TWrite(#200,X2,Y1);
           TWrite(#188,X2,Y2);
           IF CurWindow^.Shadow = On THEN BEGIN
              FOR I:= X1+1 TO X2+1 DO Mem[SegB800:(TScreenSize.X*(I-1)+(Y2))*2+1]:= 8;
              FOR I:= X1+1 TO X2+1 DO Mem[SegB800:(TScreenSize.X*(I-1)+(Y2+1))*2+1]:= 8;
              FOR I:= Y1+2 TO Y2+2 DO Mem[SegB800:(TScreenSize.X*(X2)+(I-1))*2+1]:= 8;
           END;
      END;

      DrawActiveTitle;
 END;

 PROCEDURE TWindow.ViewWindows;
 VAR Last : PWindowItem;
 BEGIN
      Last:= CurWindow;
      TopOfList; CurWindow:= Liste;
      WHILE CurWindow <> NIL DO BEGIN
            IF CurWindow = Last THEN WindowSelect ELSE WindowUnselect;
            FillWindow;
            IF CurWindow^.Suivant <> NIL THEN CurWindow:= CurWindow^.Suivant ELSE Break;
      END;
      CurWindow:= Last;
 END;

 PROCEDURE TWindow.Run;
 BEGIN
      ViewWindows;
 END;

 DESTRUCTOR TWindow.Done;
 VAR Cur : PWindowItem;
 BEGIN
      TopOfList;
      WHILE Liste^.Suivant <> NIL DO BEGIN
            Cur:= Liste;
            Dispose(Cur);
            Cur:= NIL;
            Liste:= Liste^.Suivant;
      END;
      Cur:= Liste;
      Dispose(Cur);
      Liste:= NIL;
 END;

 {***********}

 CONSTRUCTOR TLabel.Init;
 BEGIN
      Liste:= NIL; CurLabel:= NIL;
      WITH Palette DO BEGIN
           Selected.X:= 14; Selected.Y:= 7;
           Unselected.X:= 0; Unselected.Y:= 7;
           Disabled.X:= 8; Disabled.Y:= 7;
      END;
 END;

 PROCEDURE TLabel.NewLabel;
 VAR Nouveau : PLabelItem;
 BEGIN
      New(Nouveau);
      IF Liste <> NIL THEN BEGIN
         WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
         Liste^.Suivant:= Nouveau;
         Nouveau^.Name:= LabelName;
         Nouveau^.Ligne:= L;
         Nouveau^.Col:= C;
         Nouveau^.Status:= Ls;
         Nouveau^.Suivant:= NIL;
         Nouveau^.Precedent:= Liste;
         Liste:= Liste^.Suivant;
      END ELSE BEGIN
         Liste:= Nouveau;
         Liste^.Name:= LabelName;
         Liste^.Ligne:= L;
         Liste^.Col:= C;
         Liste^.Status:= Ls;
         Liste^.Suivant:= NIL;
         Liste^.Precedent:= NIL;
      END;
      IF CurLabel = NIL THEN CurLabel:= Liste;
 END;

 PROCEDURE TLabel.TopOfList;
 BEGIN
      WHILE Liste^.Precedent <> NIL DO Liste:= Liste^.Precedent;
 END;

 PROCEDURE TLabel.EndOfList;
 BEGIN
      WHILE Liste^.Suivant <> NIL DO Liste:= Liste^.Suivant;
 END;

 PROCEDURE TLabel.FirstLabel;
 BEGIN
      TopOfList;
      CurLabel:= Liste;
 END;

 PROCEDURE TLabel.LastLabel;
 BEGIN
      EndOfList;
      CurLabel:= Liste;
 END;

 PROCEDURE TLabel.GotoLabel;
 VAR Count : WORD;
 BEGIN
      TopOfList; Count:= 0;
      WHILE Count < LabelNo DO BEGIN
            IF Liste^.Suivant <> NIL THEN Liste:= Liste^.Suivant ELSE Break;
            Count:= Count+1;
      END;
      CurLabel:= Liste;
 END;


 PROCEDURE TLabel.LabelSelect;
 BEGIN
      TColor(Palette.Selected.X, Palette.Selected.Y);
      TWrite(CurLabel^.Name, CurLabel^.Ligne,CurLabel^.Col);
 END;

 PROCEDURE TLabel.LabelUnselect;
 BEGIN
      IF CurLabel^.Status = NormalLabel THEN TColor(Palette.Unselected.X, Palette.Unselected.Y)
        ELSE TColor(Palette.Disabled.X, Palette.Disabled.Y);
      TWrite(CurLabel^.Name, CurLabel^.Ligne,CurLabel^.Col);
 END;

 PROCEDURE TLabel.NextLabel;
 BEGIN
      IF CurLabel^.Suivant <> NIL THEN CurLabel:= CurLabel^.Suivant;
 END;

 PROCEDURE TLabel.PreviousLabel;
 BEGIN
      IF CurLabel^.Precedent <> NIL THEN CurLabel:= CurLabel^.Precedent;
 END;

 PROCEDURE TLabel.ViewLabels;
 VAR Last : PLabelItem;
 BEGIN
      IF Liste = NIL THEN Exit;
      Last:= CurLabel;
      TopOfList; CurLabel:= Liste;
      WHILE CurLabel <> NIL DO BEGIN
            LabelUnselect;
            IF CurLabel^.Suivant <> NIL THEN CurLabel:= CurLabel^.Suivant ELSE Break;
      END;
      CurLabel:= Last;
 END;

 DESTRUCTOR TLabel.Done;
 VAR Cur : PLabelItem;
 BEGIN
      TopOfList;
      WHILE Liste^.Suivant <> NIL DO BEGIN
            Cur:= Liste;
            Dispose(Cur);
            Cur:= NIL;
            Liste:= Liste^.Suivant;
      END;
      Cur:= Liste;
      Dispose(Cur);
      Liste:= NIL;
 END;

 BEGIN
 END.